$JBC::Version = "4.1.0";
$itworks = "w00t2";

exec("./src/support/TCPClient.cs");
exec("./src/support/tango.cs");
exec("./src/profiles.cs");
exec("./src/announce.cs");
exec("./src/hud.cs");
exec("./src/menu.cs");
exec("./src/web.cs");
exec("./src/playerlist.cs");
exec("./src/playGui.cs");
exec("./src/settings.cs");
exec("./src/weaponSwitcher.cs");
exec("./src/achievements.cs");
exec("./src/lastRequest.cs");
exec("./src/updater.cs");

if(isObject(JBC_Playerlist))
	JBC_Playerlist.delete();
exec("./guis/JBC_Playerlist.gui");

if(isObject(JBC_Menu))
	JBC_Menu.delete();
exec("./guis/JBC_Menu.gui");

if(isObject(JBC_MessageBoxOk))
	JBC_MessageBoxOk.delete();
exec("./guis/JBC_MessageBoxOk.gui");

if(isObject(JBC_MessageBoxYesNo))
	JBC_MessageBoxYesNo.delete();
exec("./guis/JBC_MessageBoxYesNo.gui");

if(isObject(JBC_SearchResults))
	JBC_SearchResults.delete();
exec("./guis/JBC_SearchResults.gui");

if(isObject(JBC_LastRequestMenu))
	JBC_LastRequestMenu.delete();
exec("./guis/JBC_LastRequestMenu.gui");

function clientCmdJBC_handShake()
{
	clientCmdJBC_checkForUpdates();
	$JB::Online = 1;
}

function clientCmdJBC_doUpdates()
{
	if(!$JB::Online)
		return;

	updater.CheckForUpdates();
}

function JBC_cleanup()
{
	// support option for displaying on other servers
	cancel($JBC::HudInfoLoop);

	if(isObject(JBC_fpsDisplay))
			JBC_fpsDisplay.delete();
	if(isObject(JBC_pingDisplay))
			JBC_pingDisplay.delete();

	if(isObject(PlayGui_ShapeNameHud))
			PlayGui_ShapeNameHud.setProfile(BlockChatTextProfile);

	// This stuff should only need to be set if you were previously on the Jailbreak server.
	if($JB::Online)
	{
		Crosshair.setColor("1 1 1 1");
		clientCmdJBC_HUD_cleanup();
		clientCmdJBC_clearShop();
		clientCmdJBC_clearPlayerList();
		
		if(isObject(JBC_MenuButton))
			JBC_MenuButton.delete();
		
		$JB::Online = 0;
		$JB::spawnedOnce = 0;
		$JB::LoadedStaff = 0;
		$JB::LoadedLeaderboard = 0;
	}
}

function JBC_echo(%text)
{
	echo("\c4[Jailbreak]\c0" SPC %text);
}

if(isObject(serverConnection))
	commandToServer('gotClient');
else
	$JB::Online = 0;

package JBC_Client
{
	function showPlayerList(%val)
	{
		if($JB::Online && $JB::Pref["Playerlist"])
		{
			if($lastJBListOpen + 2 > $Sim::Time && !%val)
				return;
			
			$lastJBListOpen = $Sim::Time;
			
			clientCmdJBC_showPlayerlist();
			return;
		}
		return parent::showPlayerList(%val);
	}
	function disconnectedCleanup(%doReconnect)
	{
		schedule(0, 0, "JBC_cleanup");
		return parent::disconnectedCleanup(%doReconnect);
	}
	
	function openBSD(%val)
	{
		if($JB::Online && $BuildingDisabled)
		{
			if(!%val)
				return;
			
			JBC_ToggleMenu(1);
			return;
		}
		return parent::openBSD(%val);
	}
		
	function clientCmdmessageBoxOK(%title, %message)
	{
		if(!$JB::Online || !$JB::Pref["MessageBoxes"])
		{
			parent::clientCmdmessageBoxOK(%title, %message);
			return;
		}
		
		clientCmdJBC_messageBoxOK(%title, %message);
	}
	
	function clientCmdMessageBoxYesNo(%title, %message, %okServerCmd, %cancelServerCmd)
	{
		if(!$JB::Online || !$JB::Pref["MessageBoxes"])
		{
			parent::clientCmdMessageBoxYesNo(%title, %message, %okServerCmd, %cancelServerCmd);
			return;
		}

		clientCmdJBC_MessageBoxYesNo(%title, %message, %okServerCmd);
	}

	function ReConnectToServer()
	{
		JBC_cleanup();
		parent::ReConnectToServer();
	}

	function PlayGui::hidePaintBox(%this, %dist, %totalSteps, %currStep)
	{
		if($JB::Online)
		{
			HUD_PaintBox.setVisible(false);
			HUD_PaintNameBG.setVisible(false);
		}
		else
			return parent::hidePaintBox(%this, %dist, %totalSteps, %currStep);
	}

	function GuiControl::tangoMoveTo(%this, %xy, %ms, %easeModeX, %easeModeY)
	{
		if($JB::Pref["DisableAnimations"])
			%this.resize(getWord(%xy, 0), getWord(%xy, 1), getWord(%this.extent, 0), getWord(%this.extent, 1));
		else
			return parent::tangoMoveTo(%this, %xy, %ms, %easeModeX, %easeModeY);
	}

	function optionsDlg::applyGraphics(%this)
	{
		if($JB::Online && $JB::Pref["HUD"])
		{
			schedule(100, 0, "clientCmdJBC_createHUD");
			schedule(120, 0, "clientCmdJBC_positionHUD");
		}

		return parent::applyGraphics(%this);
	}

	function PlayGui::onRender(%this)
	{
		if($JB::Pref["DisplayStats"])
			schedule(0, 0, "clientCmdJBC_PlayGui_DisplayInfo", $JB::Pref["AlwaysShowStats"]);

		parent::onRender(%this);
		
		if($JB::Pref["AlwaysShapenames"] && $JB::Pref["Shapenames"])
			PlayGui_ShapeNameHud.setProfile(JBC_ShapeNameProfile);
	}
};
activatePackage(JBC_Client);