function clientCmdJBC_recieveAchInfo(%id, %name, %description, %progress, %finish)
{
	if(isObject(%swatch = nameToID("JBC_Ach_" @ %id)))
		%swatch.delete();

	%pos = 0 SPC JBC_Menu_Achievements.getCount() * 50 + JBC_Menu_Achievements.getCount() * 2;
	%swatch = new GuiSwatchCtrl("JBC_Ach_" @ %id)
	{
		title = %name;
		description = %description;
		progress = %progress;
		finish = %finish;

		extent = "360 50";
		position = %pos;
		color = "200 200 200 225";
	};

	if(%progress >= %finish)
		%gradBitmap = "Add-Ons/Client_Jailbreak/res/green";
	else
		%gradBitmap = "Add-Ons/Client_Jailbreak/res/red";

	%swatch.bitmap = new GuiBitmapCtrl()
	{
		extent = "360 50";
		bitmap = %gradBitmap;
		mColor = "255 255 255 60";
	};
	%swatch.add(%swatch.bitmap);
 
	%swatch.add(new GuiTextCtrl()
	{
		profile = JBC_LargeHUDLabelText;
		text = "\c8" @ %name;
		extent = "360 20";
		position = "6 4";
	});

	%swatch.add(new GuiTextCtrl()
	{
		profile = JBC_TabTextProfile;
		text = "\c8" @ %description;
		extent = "360 20";
		position = "6 28";
	});

	%swatch.progressLabel = new GuiTextCtrl()
	{
		profile = JBC_TabTextRightProfile;
		text = "\c8" @ %progress @ "/" @ %finish;
		extent = "100 30";
		minExtent = "100 20";
		position = "250 6";
	};
	%swatch.add(%swatch.progressLabel);

	%swatch.add(new GuiMouseEventCtrl(JBC_AchievementMouseEvent)
	{
		extent = "360 50";
		info = %swatch;
	});

	JBC_Menu_Achievements.add(%swatch);

	JBC_Menu_Achievements.resize(1, 1, 365, getWord(%pos, 1));
}

function clientCmdJBC_updateAchievement(%name, %newValue)
{
	%ach = -1;
	for(%i=0; %i < JBC_Menu_Achievements.getCount(); %i++)
	{
		%search = JBC_Menu_Achievements.getObject(%i);
		if(%search.title $= %name)
		{
			%ach = %search;
			break;
		}
	}

	if(!isObject(%ach))
	{
		warn("Unable to update achievement" SPC %name @ ". Does not exist.");
		return;
	}
	%old = %ach.progress;
	%ach.progress = %newValue;

	if(%ach.progress >= %ach.finish)
		%ach.bitmap.setBitmap("Add-Ons/Client_Jailbreak/res/green");
	else if(%ach.progress < %ach.finish)
		%ach.bitmap.setBitmap("Add-Ons/Client_Jailbreak/res/red");

	%ach.progressLabel.setText("\c8" @ %ach.progress @ "/" @ %ach.finish);
}

function clientCmdJBC_clearAchievements()
{
	JBC_Menu_Achievements.clear();
}

function JBC_AchievementMouseEvent::onMouseEnter(%this)
{
	%this.info.bitmap.mColor = "255 255 255 120";
}

function JBC_AchievementMouseEvent::onMouseLeave(%this)
{
	%this.info.bitmap.mColor = "255 255 255 60";
}