function clientCmdJBC_HUD_cleanup()
{
	if(isObject(JBC_weaponSwitcher))
		JBC_weaponSwitcher.delete();
	if(isObject(JBC_HUD_Warden))
		JBC_HUD_Warden.delete();
	if(isObject(JBC_HUD_Money))
		JBC_HUD_Money.delete();
	if(isObject(JBC_HUD_Health))
		JBC_HUD_Health.delete();
	if(isObject(JBC_HUD_Timer))
		JBC_HUD_Timer.delete();
	if(isObject(JBC_HUD_Teamliving))
		JBC_HUD_Teamliving.delete();
}


///////////////////
// HUD Elements
///////////////////

function clientCmdJBC_createHUD()
{
	if(!$JB::Online)
		return;
	
	// Warden display
	if(isObject(JBC_HUD_Warden))
		JBC_HUD_Warden.delete();
	
	%warden = new GuiSwatchCtrl(JBC_HUD_Warden)
	{
		position = "-100 -100";
		color = "0 0 0 0";
	};
	%warden.icon = new GuiBitmapCtrl(JBC_HUD_Warden_Icon)
	{
		bitmap = "Add-ons/Client_Jailbreak/res/icon/warden";
		extent = "48 60";
	};
	
	%warden.mouseEvent = new GuiMouseEventCtrl(JBC_moverSwatch)
	{
		lockMouse = "1";
        moveObject = "JBC_HUD_Warden";
		extent = "150 60";
	};
	
	%warden.label = new GuiTextCtrl()
	{
		minExtent = "85 32";
		profile = JBC_WardenHUDLabelText;
		position = "6 0";
	};
	
	%warden.background = new GuiSwatchCtrl()
	{
		color =  "0 0 0 110";
		position = "0 14";
	};
	
	%warden.add(%warden.background);
	%warden.background.add(%warden.label);
	%warden.add(%warden.icon);
	%warden.add(%warden.mouseEvent);
	
	NewChatHUD.add(%warden);
	clientCmdJBC_HUD_setWarden("Loading");
	
	
	// Money
	if(isObject(JBC_HUD_Money))
		JBC_HUD_Money.delete();
	
	%container = new GuiSwatchCtrl(JBC_HUD_Money)
	{
		extent = "180 60";
		color = "0 0 0 0";
	};
	%mouseEvent = new GuiMouseEventCtrl(JBC_moverSwatch)
	{
		lockMouse = "1";
        moveObject = "JBC_HUD_Money";
		extent = "180 60";
	};
	%moneyLabel = new GuiBitmapCtrl()
	{
		extent = "45 45";
		bitmap = "Add-ons/Client_Jailbreak/res/icon/HUD_money";
	};
	%container.moneyBack = new GuiSwatchCtrl()
	{
		color =  "0 0 0 110";
		extent = "70 30";
		position = "30 10";
	};
	%container.moneySide = new GuiBitmapCtrl()
	{
		mColor =  "0 0 0 110";
		extent = "10 30";
		position = "100 10";
		bitmap = "Add-ons/Client_Jailbreak/res/sidebar";
	};
	%container.moneyLabel = new GuiTextCtrl()
	{
		profile = JBC_LargeHUDLabelText;
		extent = "60 30";
		text = "\c6$500";
		position = "50 11";
	};
	%container.add(%container.moneySide);
	%container.add(%container.moneyBack);
	%container.add(%container.moneyLabel);	
	%container.add(%moneyLabel);
	%container.add(%mouseEvent);
	NewChatHUD.add(%container);
	
	// Health
	if(isObject(JBC_HUD_Health))
		JBC_HUD_Health.delete();
	
	%container = new GuiSwatchCtrl(JBC_HUD_Health)
	{
		extent = "180 60";
		color = "0 0 0 0";
	};
	%mouseEvent = new GuiMouseEventCtrl(JBC_moverSwatch)
	{
		lockMouse = "1";
        moveObject = "JBC_HUD_Health";
		extent = "180 60";
	};

	%healthLabel = new GuiBitmapCtrl()
	{
		extent = "45 45";
		bitmap = "Add-ons/Client_Jailbreak/res/icon/HUD_health";
	};
	%container.healthBack = new GuiSwatchCtrl()
	{
		color =  "0 0 0 110";
		extent = "72 30";
		position = "30 10";
	};
	%container.healthSide = new GuiBitmapCtrl()
	{
		mColor =  "0 0 0 110";
		extent = "10 30";
		position = "102 10";
		bitmap = "Add-ons/Client_Jailbreak/res/sidebar";
	};
	%container.healthLabel = new GuiTextCtrl()
	{
		profile = JBC_LargeHUDLabelText;
		extent = "60 30";
		text = "\c6100%";
		position = "50 11";
		minExtent = "50 11";
	};
	%container.add(%container.healthSide);
	%container.add(%container.healthBack);
	%container.add(%container.healthLabel);	
	%container.add(%healthLabel);
	%container.add(%mouseEvent);
	NewChatHUD.add(%container);
	
	// Timer
	if(isObject(JBC_HUD_Timer))
		JBC_HUD_Timer.delete();
	
	%container = new GuiSwatchCtrl(JBC_HUD_Timer)
	{
		extent = "130 45";
		color = "0 0 0 0";
	};
	%mouseEvent = new GuiMouseEventCtrl(JBC_moverSwatch)
	{
		lockMouse = "1";
        moveObject = "JBC_HUD_Timer";
		extent = "130 45";
	};
	%timerLabel = new GuiBitmapCtrl()
	{
		extent = "45 45";
		position = "80 0";
		bitmap = "Add-ons/Client_Jailbreak/res/icon/HUD_clock";
	};
	%container.timerBack = new GuiSwatchCtrl()
	{
		color =  "0 0 0 110";
		extent = "56 30";
		position = "34 10";
	};
	%container.timerSide = new GuiBitmapCtrl()
	{
		mColor =  "0 0 0 110";
		extent = "10 30";
		position = "24 10";
		bitmap = "Add-ons/Client_Jailbreak/res/sidebar2";
	};
	%container.timerLabel = new GuiTextCtrl()
	{
		profile = JBC_LargeHUDLabelText;
		extent = "65 30";
		text = "\c60:00";
		position = "36 11";
	};
	%container.add(%container.timerSide);
	%container.add(%container.timerBack);
	%container.add(%container.timerLabel);	
	%container.add(%timerLabel);
	%container.add(%mouseEvent);
	NewChatHUD.add(%container);
	
	// TeamLiving
	if(isObject(JBC_HUD_Teamliving))
		JBC_HUD_Teamliving.delete();

	%container = new GuiSwatchCtrl(JBC_HUD_Teamliving)
	{
		extent = "130 80";
		color = "0 0 0 0";
	};
	%mouseEvent = new GuiMouseEventCtrl(JBC_moverSwatch)
	{
		lockMouse = "1";
        moveObject = "JBC_HUD_Teamliving";
		extent = "130 80";
	};
	%teamlivingLabel = new GuiBitmapCtrl()
	{
		color = "0 35 50 186";
		extent = "72 72";
		bitmap = "Add-ons/Client_Jailbreak/res/icon/HUD_gp";
	};

	%container.teamlivingBack = new GuiSwatchCtrl()
	{
		color =  "0 0 0 110";
		extent = "56 30";
		position = "45 15";
	};
	%container.teamlivingSide = new GuiBitmapCtrl()
	{
		mColor =  "0 0 0 110";
		extent = "10 30";
		position = "101 15";
		bitmap = "Add-ons/Client_Jailbreak/res/sidebar";
	};
	%container.teamlivingLabel = new GuiTextCtrl()
	{
		profile = JBC_LargeHUDLabelText;
		extent = "60 30";
		text = "\c63:17";
		position = "60 16";
	};
	%container.add(%container.teamlivingSide);
	%container.add(%container.teamlivingBack);
	%container.add(%container.teamlivingLabel);	
	%container.add(%teamlivingLabel);
	%container.add(%mouseEvent);
	NewChatHUD.add(%container);
	
	PlayGui_ShapeNameHud.setProfile(JBC_ShapeNameProfile);
	schedule(500, 0, "clientCmdJBC_hideDefaultHUD");
}

function clientCmdJBC_positionHUD()
{
	if(!$JB::Online)
		return;
	
	%res = getRes();
	%basePos = JBC_weaponSwitcher.position;
	
	JBC_weaponSwitcher.toggle();

	// HUD Positions
	%savedPos = $JB::Pref["HUDPosition", "JBC_HUD_Money"];
	if(JBC_checkHUDPos(%savedPos))
		JBC_HUD_Money.position = %savedPos;
	else
		JBC_HUD_Money.position = 35 SPC getWord(%res, 1) - 160;

	%savedPos = $JB::Pref["HUDPosition", "JBC_HUD_Health"];
	if(JBC_checkHUDPos(%savedPos))
		JBC_HUD_Health.position = %savedPos;
	else
		JBC_HUD_Health.position = 35 SPC getWord(%res, 1) - 100;

	%savedPos = $JB::Pref["HUDPosition", "JBC_HUD_Timer"];
	if(JBC_checkHUDPos(%savedPos))
		JBC_HUD_Timer.position = %savedPos;
	else
		JBC_HUD_Timer.position = mFloor((getWord(%res, 0) / 2 - getWord(JBC_HUD_Timer.extent, 0) / 2) - 260) SPC getWord(%res, 1) - 75;

	%savedPos = $JB::Pref["HUDPosition", "JBC_HUD_Teamliving"];
	if(JBC_checkHUDPos(%savedPos))
		JBC_HUD_Teamliving.position = %savedPos;
	else
		JBC_HUD_Teamliving.position = mFloor(getWord(%res, 0) / 2 - getWord(JBC_HUD_Teamliving.extent, 0) / 2) + 260 SPC getWord(%res, 1) - 75;

	%savedPos = $JB::Pref["HUDPosition", "JBC_HUD_Warden"];
	if(JBC_checkHUDPos(%savedPos))
		JBC_HUD_Warden.position = %savedPos;
	else
	{
		JBC_HUD_Warden.moved = 0;
		clientCmdJBC_HUD_setWarden($JB::currentWarden);	
	}

	clientCmdJBC_setMenuButtonVisible(true);
	
	if($JB::Pref["DisplayStats"])
		clientCmdJBC_PlayGui_DisplayInfo(true);
}


function clientCmdJBC_resetHUDPositions()
{
	if(!$JB::Online)
		return;

	deleteVariables("$JB::PrefHUDPosition*");
	clientCmdJBC_positionHUD();
}


function JBC_checkHUDPos(%pos)
{
	if(%pos $= "")
		return 0;

	if(getWord(%pos, 0) > getWord(getRes(), 0) || getWord(%pos, 1) > getWord(getRes(), 1))
	{
		clientCmdmessageBoxOK("Crown's Jailbreak", "Looks like some of your HUD was off the screen and invisible to you. We've moved things back to their default positions.");
		clientCmdJBC_resetHUDPositions();
		return 0;
	}
	else
	{
		return 1;
	}
}

function clientCmdJBC_onAddMoney(%amt)
{
	if($JB::Pref["HUD"] == 0)
		return;
		
	for(%i=0; %i < NewChatHUD.getCount(); %i++)
	{
		%obj = NewChatHUD.getObject(%i);
		if(%obj.getName() !$= "JBC_MoneyNotification")
			continue;

		%recent = %obj;
	}

	if(isObject(%recent))
		%position = vectorAdd(%recent.position, "0 0");
	else
		%position = vectorAdd(JBC_HUD_Money.position, "43 10");

	if(%amt >= 0)
		%text = "\c2+" @ NumberToString(%amt);
	else
	{
		%amt = strReplace(%amt, "-", "");
		%text = "\c0-" @ NumberToString(%amt);
	}

	%textCtrl = new GuiTextCtrl()
	{
		profile = "JBC_WardenHUDLabelText";
		extent = "60 30";
		position = "4 0";
	};
	%textCtrl.setText(%text);

	%display = new GuiBitmapCtrl(JBC_MoneyNotification)
	{
		bitmap = "Add-Ons/Client_Jailbreak/res/nameback";
		extent = getWord(%textCtrl.extent, 0) + 11 SPC 28;
		position = %position;
		mColor = "0 0 0 110";
	};
	%display.add(%textCtrl);

	%display.tangoMoveTo(vectorAdd(%display.position, "0 -40"), 150, "quad");
	%display.schedule(2000, "delete");

	NewChatHUD.add(%display);
}
	
function clientCmdJBC_HUD_setMoney(%money)
{
	if(!$JB::Online)
		return;
	
	%background = JBC_HUD_Money.moneyBack;
	%label = JBC_HUD_Money.moneyLabel;
	
	%label.setText("\c6" @ %money);
	%background.extent = getWord(%label.extent, 0) + 26 SPC getWord(%background.extent, 1);
	JBC_HUD_Money.moneySide.position = getWord(%background.extent, 0) + 30 SPC getWord(JBC_HUD_Money.moneySide.position, 1);
}

function clientCmdJBC_HUD_setTimer(%time)
{
	if(!$JB::Online)
		return;
	
	%time = "\c6" @ getTimeString(%time);
	JBC_HUD_Timer.timerLabel.setText(%time);
}

function clientCmdJBC_HUD_setHealth(%health)
{
	if(!$JB::Online)
		return;
	
	JBC_HUD_Health.healthLabel.setText("\c6" @ %health);
}

function clientCmdJBC_HUD_setTeamLiving(%living)
{
	if(!$JB::Online || !$JB::Pref["HUD"])
		return;
	
	JBC_HUD_Teamliving.teamlivingLabel.setText("\c6" @ %living);
}

function JBC_HUD_hideWarden()
{
	cancel($JBC_HUD_hideWarden);
	%ctrl = JBC_HUD_Warden.background;
	

	if(getWord(%ctrl.extent, 0) <= 0)
		return;

	%ctrl.extent = vectorSub(%ctrl.extent, 4 SPC 0);
	%ctrl.position = vectorAdd(%ctrl.position, 4 SPC 0);
		
	$JBC_HUD_hideWarden = schedule(1, 0, "JBC_HUD_hideWarden");
}
	
function clientCmdJBC_HUD_setWarden(%warden)
{
	if(!$JB::Online || !$JB::Pref["HUD"])
		return;
	%this = JBC_HUD_Warden;	
	$JB::currentWarden = %warden;

	%this.label.extent = "0 0";
	%this.label.setText("\c6" @ %warden @ " ");
	%extent = getWord(%this.label.extent, 0);
	if(%extent < 80)
	{
		%extent = 85;
		%this.label.extent = "85 32";
	}
	
	if(%warden $= "")
		JBC_HUD_hideWarden();

	%this.extent = %extent + 80 SPC 60;
	JBC_HUD_Warden.background.position = "0 14";
	%this.mouseEvent.extent = %extent + 80 SPC 60;
	%this.background.extent = %extent + 20 SPC 32;
	JBC_HUD_Warden_Icon.position = %extent + 4 SPC 0;
	%res = getRes();
	if(!%this.moved)
		%this.position = getWord(%res, 0) - %extent - 80 SPC 20 SPC 0;
}


function clientCmdJBC_setCrosshair(%color)
{
	if(!$JB::Online)
		return;

	if(%color $= "")
	{
		%color = "1 1 1 1";
	}

	Crosshair.setColor(%color);
}