function JBC_LastRequestMenu::onWake(%this)
{
	JBC_AddLastRequests();
	JBC_LR_Main.resize(0, 0, 375, 450);
	JBC_LR_SetHeaderText("Pick a Request");

	if(JBC_LastRequestWindow.position $= "0 0")
		JBC_LastRequestWindow.center();

	JBC_LR_BottomButton.command = "canvas.popDialog(\"JBC_LastRequestMenu\");alxPlay(JBC_Sound_Close);";
	JBC_LR_BottomButton.text = "\c6Close";
}

function JBC_LR_SetHeaderText(%text)
{
	%main = JBC_LR_Header;
	if(%main.getCount() > 1)
		for(%i=%main.getCount(); %i > 1; %i--)
			%main.getObject(%i - 1).delete();

	if(isObject(%currText = %main.getObject(0)))
	{
		%currText.tangoMoveTo("-200 0", 500, "quad");
		%currText.schedule(501, "delete");
	}

	%text = new GuiMLTextCtrl()
	{
		extent = "199 28";
		text = "<just:center><font:arial bold:30><color:ffffff>" @ %text;
		position = "400 0";
	};
	%main.add(%text);
	%text.schedule(0, "tangoMoveTo", "0 0 ", 500, "quad");
}

function clientCmdJBC_LR_addRequest(%title, %icon, %deathmatch)
{
	%main = JBC_LR_Main;
	for(%i=0; %i < %main.getCount(); %i++)
		if(!%main.getObject(%i).removing)
			%count++;

	%main = JBC_LR_Main;

	%pos = %count * 64 + %count * 2;
	%swatch = new GuiSwatchCtrl()
	{
		extent = "360 64";
		position = "400" SPC %pos;
		color = "220 220 220 225";
	};

	%swatch.add(new GuiMLTextCtrl()
	{
		extent = "290 64";
		position = "0 12";
		text = "<just:center><font:arial bold:40><color:424242>" @ %title;
	});

	%swatch.add(new GuiBitmapCtrl()
	{
		extent = "64 64";
		position = "280 0";
		bitmap = %icon;
	});

	%swatch.add(new GuiMouseEventCtrl(JBC_LRMouseEvent)
	{
		extent = %swatch.extent;
		swatch = %swatch;
		title = %title;
		type = "request";
		deathmatch = %deathmatch;
	});

	%swatch.tangoMoveTo("0" SPC %pos, 500, "quad");
	if(%pos > 458)
		JBC_LR_Main.resize(0, 0, 375, %pos + 64);
	%main.add(%swatch);
}

function clientCmdJBC_LR_selectRequest(%name)
{
	if($JBC::LastLRSelectTime + 0.5 > $Sim::Time)
		return;

	$JBC::LastLRSelectTime = $Sim::Time;

	%main = JBC_LR_Main;
	for(%i=0; %i < %main.getCount(); %i++)
	{
		%swatch = %main.getObject(%i);
		%swatch.tangoMoveTo("-400" SPC getWord(%swatch.position, 1), 500, "quad");
		%swatch.schedule(501, "delete");
		%swatch.removing = true;
	}
	JBC_LR_BottomButton.setText("\c6Back");
	JBC_LR_BottomButton.command = "JBC_LastRequestMenu.onWake();alxPlay(JBC_Sound_Close);";
	$JBC::SelectedLR = %name;
	if(%name !$= "Deathmatch")
	{
		JBC_LR_SetHeaderText("Pick a Guard");
		commandToServer('LR_requestGuards');
	}
	else
	{
		JBC_LR_SetHeaderText("Pick a Weapon");
		commandToServer('LR_requestDMWeapons');
	}
}

function clientCmdJBC_LR_receiveGuard(%blid, %name, %icon)
{
	%main = JBC_LR_Main;
	for(%i=0; %i < %main.getCount(); %i++)
		if(!%main.getObject(%i).removing)
			%count++;

	%pos = %count * 34 + %count * 2;

	%swatch = new GuiSwatchCtrl()
	{
		extent = "375 34";
		position = "400" SPC %pos;
		color = "63 81 181 255";

		blid = %blid;
	};
	%swatch.add(new GuiMLTextCtrl()
	{
		extent = "300 34";
		text = "<font:arial bold:24><color:eceff1>" @ %name;
		position = "80 6";
	});
	%swatch.add(new GuiBitmapCtrl()
	{
		position = "27 8";
		extent = "16 16";
		bitmap = "Add-Ons/Client_Jailbreak/res/icon/" @ %icon;
	});

	%swatch.add(new GuiMouseEventCtrl(JBC_LRMouseEvent)
	{ 
		extent = %swatch.extent;
		swatch = %swatch;
		type = "guard";
	});
	%swatch.tangoMoveTo("0" SPC %pos, 500, "quad");
	%main.add(%swatch);
	if(%pos > 458)
		%main.resize(0, 0, 375, %pos + 34);

	if(%pos > 458)
		JBC_LR_Main.resize(0, 0, 375, %pos + 64);
	else
		JBC_LR_Main.resize(0, 0, 375, 450);
}

function JBC_LRMouseEvent::onMouseEnter(%this)
{
	if(%this.type $= "request")
		%this.swatch.color = "160 160 160 255";
	else if(%this.type $= "guard")
		%this.swatch.color = "63 81 181 140";
}

function JBC_LRMouseEvent::onMouseLeave(%this)
{
	if(%this.type $= "request")
		%this.swatch.color = "220 220 220 225";
	else if(%this.type $= "guard")
		%this.swatch.color = "63 81 181 255";
}

function JBC_LRMouseEvent::onMouseDown(%this)
{
	alxPlay(JBC_Sound_Open);
	if(%this.type $= "request")
		clientCmdJBC_LR_selectRequest(%this.title);
	else if(%this.type $= "guard")
		clientCmdJBC_LR_selectGuard(%this.swatch.blid);
}

function JBC_LRMouseEvent::onRightMouseDown(%this)
{
	eval(JBC_LR_BottomButton.command);
}

function JBC_AddLastRequests()
{
	JBC_LR_Main.clear();
	clientCmdJBC_LR_addRequest("Gun Toss", "Add-Ons/Weapon_Gun/Icon_gun");
	clientCmdJBC_LR_addRequest("Shot for Shot", "Add-Ons/Weapon_Guns_Akimbo/Icon_2guns");
	clientCmdJBC_LR_addRequest("Deathmatch", "Add-Ons/Client_Jailbreak/res/skull");
	clientCmdJBC_LR_addRequest("Gameroom", "Add-Ons/Client_Jailbreak/res/gameroom");
	clientCmdJBC_LR_addRequest("Custom", "Add-Ons/Client_Jailbreak/res/custom");
}