function JBC_setTab(%tab)
{
	JBC_setHatSpinning(0);
	clientCmdJBC_setPreviewMode(0);
	
	if($JBC::CurrentTab !$= %tab)
		alxPlay(JBC_Sound_Pop);
	$JBC::CurrentTab = %tab;

	%tabs = "Profile Shop Settings Leaderboard Staff Bans";
	for(%i=0; %i < getWordCount(%tabs); %i++)
	{
		%tabName = getWord(%tabs, %i);
		if(isObject(%obj = nameToID("JBC_Menu_Tab_" @ %tabName)))
			%obj.setVisible(false);
		if(isObject(%obj = nameToID("JBC_Menu_Button_" @ %tabName)))
		{
			%obj.mColor = "54 79 103 230";
			%obj.getObject(0).setText("<color:ffffff><font:arial bold:16>" @ stripMLControlChars(%obj.getObject(0).getText()));
		}
	}
	
	if(isObject(%tabSwatch = nameToID("JBC_Menu_Tab_" @ %tab)))
	{
		%tabSwatch.setVisible(true);
		%button = nameToID("JBC_Menu_Button_" @ %tab);
		// 235 238 242
		%button.mColor = "225 225 225 240";
		%button.getObject(0).setText("<color:424242><font:arial bold:16>" @ stripMLControlChars(%button.getObject(0).getText()));
		
		JBC_MenuButtonSwatch.remove(%button);
		JBC_MenuButtonSwatch.add(%button);
		
		if(%tab $= "Shop")
			JBC_setHatSpinning(1);
		else if(%tab $= "Leaderboard" && !$JB::LoadedLeaderboard)
			clientCmdJBC_getLeaderboard("money");
		else if(%tab $= "Staff" && !$JB::LoadedStaff)
			clientCmdJBC_loadStaff();
	}
	
}

function clientCmdJBC_setTab(%tab)
{
	if(!$JB::Online)
		return;
	
	if(!JBC_Menu.isAwake())
		canvas.pushDialog(JBC_Menu);
	
	JBC_setTab(%tab);
}

function JBC_Shop_SetTab(%tab)
{
	JBC_Menu_Tab_Shop_Filter_Owned.setVisible(false);
	JBC_setHatSpinning(0);

	if($JBC::CurrentShopTab !$= %tab)
		alxPlay(JBC_Sound_Pop);
	$JBC::CurrentShopTab = %tab;

	JBC_Menu_Tab_Shop_Hats.setVisible(false);
	JBC_Menu_Shop_Button_Hats.mColor = "54 79 103 240";
	JBC_Menu_Shop_Button_Hats.getObject(0).setText("<color:ffffff><font:arial bold:16>" @ stripMLControlChars(JBC_Menu_Shop_Button_Hats.getObject(0).getText()));

	JBC_Menu_Tab_Shop_Trails.setVisible(false);
	JBC_Menu_Shop_Button_Trails.mColor = "54 79 103 240";
	JBC_Menu_Shop_Button_Trails.getObject(0).setText("<color:ffffff><font:arial bold:16>" @ stripMLControlChars(JBC_Menu_Shop_Button_Trails.getObject(0).getText()));

	JBC_Menu_Tab_Shop_Buffs.setVisible(false);
	JBC_Menu_Shop_Button_Buffs.mColor = "54 79 103 240";
	JBC_Menu_Shop_Button_Buffs.getObject(0).setText("<color:ffffff><font:arial bold:16>" @ stripMLControlChars(JBC_Menu_Shop_Button_Buffs.getObject(0).getText()));

	JBC_Menu_Tab_Shop_Cosmetics.setVisible(false);
	JBC_Menu_Shop_Button_Cosmetics.mColor = "54 79 103 240";
	JBC_Menu_Shop_Button_Cosmetics.getObject(0).setText("<color:ffffff><font:arial bold:16>" @ stripMLControlChars(JBC_Menu_Shop_Button_Cosmetics.getObject(0).getText()));


	if(isObject(%tabSwatch = nameToID("JBC_Menu_Tab_Shop_" @ %tab)))
	{
		%tabSwatch.setVisible(true);
		%button = nameToID("JBC_Menu_Shop_Button_" @ %tab);
		%button.mColor = "225 225 225 220";
		%button.getObject(0).setText("<color:424242><font:arial bold:16>" @ stripMLControlChars(%button.getObject(0).getText()));

		if(%tab $= "Hats")
		{
			JBC_Menu_Tab_Shop_Filter_Owned.setVisible(true);
			JBC_setHatSpinning(1);
		}
	}
}

function JBC_MenuWindow::onWake(%this)
{
	if(%this.position $= "0 0")
		%this.schedule(100, "tangoCenter", "500", "elastic");

	if(stripMLControlChars(JBC_Menu_Profile_Label.getText()) $= "Stats")
	{
		commandToServer('requestStats');
		JBC_Menu_Tab_Profile_SearchText.schedule(100, "setText", $Pref::Player::NetName);
	}

	JBC_Menu_Tab_Profile_SearchText.schedule(0, makeFirstResponder, false);
	if(JBC_Menu_Tab_Shop.visible && JBC_Menu_Tab_Shop_Hats.visible)
		JBC_setHatSpinning(1);
	else 
		JBC_setHatSpinning(0);
	
	commandToServer('requestShopMoney');
	
	for(%i=0; %i < JBC_Shop_HatsContainer.getCount(); %i++)
	{
		%swatch = JBC_Shop_HatsContainer.getObject(%i);
		if(isObject(%swatch.ObjView))
		{
			%swatch.objView.schedule(0, "setCamera");
			%swatch.objView.schedule(0, "setOrbitDist", 8.5);
		}
	}
}

function JBC_Menu::onSleep(%this)
{
	clientCmdJBC_setPreviewMode(0);
	JBC_setHatSpinning(0);
}

function JBC_toggleMenu(%on)
{
	if(!%on)
		return;
	
	if(JBC_Menu.isAwake())
		canvas.popDialog(JBC_Menu);
	else
		canvas.pushDialog(JBC_Menu);
}

function clientCmdJBC_receiveShopItem(%type, %name, %price, %owned, %vip, %icon)
{
	if(!$JB::Online)
		return;
	
	if(!isObject(JBC_ShopGroup))
		new SimGroup(JBC_ShopGroup);
	
	if(isObject(%info = nameToID("JBC_ShopItem_" @ %name)))
	{
		if(isObject(%info.swatch))
			%info.swatch.delete();
		%info.delete();
	}
	
	%info = new SimObject("JBC_ShopItem_" @ %name)
	{
		type = %type;
		name = %name;
		price = %price;
		owned = %owned;
		vip = %vip;
	};
	JBC_ShopGroup.add(%info);
	
	if(isObject(%swatch = nameToID("JBC_ShopItemSwatch_" @ %name)))
		%swatch.delete();
	
	if(%type $= "Hats")
	{
		%container = JBC_Shop_HatsContainer;
		%count = %container.getCount();
		%swatchPos = mFloor( ((%count % 6) * 120) + 30 ) SPC mFloor(%count / 6) * 130;
		%container.resize(getWord(%container.position, 0), getWord(%container.position, 1), 784, mFloor(%count / 6) * 130 + 130);
		
		%swatch = new GuiSwatchCtrl()
		{
			extent = "120 130";
			position = %swatchPos;
			color = "0 0 0 0";
		};
		if(%name !$= "No Hat")
		{
			%info.equippedSwatch = new GuiBitmapCtrl()
			{
				extent = %swatch.extent;
				bitmap = "Add-Ons/Client_Jailbreak/res/cloud";
				visible = false;
			};
			%swatch.add(%info.equippedSwatch);

			%swatch.add(%swatch.objView = new GuiObjectView()
			{
				extent = "120 130";
				forceFOV = "10";
				lightDirection = "0.721277 0.57735 0.57735";
				lightColor = "1.000000 1.000000 1.000000 1.000000";
				ambientColor = "0.500000 0.500000 0.500000 1.000000";
				info = %info;
			});
			%swatch.objView.setObject("", "Add-Ons/Gamemode_Jailbreak/datablocks/hats/" @ %name @ "/" @ %name @ ".dts", "", "");
			%swatch.objView.schedule(0, "setCamera");
			%swatch.objView.schedule(0, "setOrbitDist", 8.5);
			%swatch.objView.schedule(0, "setCameraRot", 0, 0, 3.5);
			%swatch.objView.spinLoop();
		}
		else
		{
			%swatch.add(%swatch.noneBitmap = new GuiBitmapCtrl()
			{
				bitmap = "Add-Ons/Client_Jailbreak/res/none";
				extent = "130 130";
			});
		}
		
		%tagX = 100;
		%tagXPos = 10;
		%isHat = 1;
		%tagYPos = 105;
		
		%container.add(%swatch);
	}
	else if(%type $= "Trails")
	{
		%container = JBC_Shop_TrailsContainer;
		%count = %container.getCount();
		%swatchPos = mFloor( ((%count % 5) * 160) - 6) SPC mFloor(%count / 5) * 160;
		%container.resize(getWord(%container.position, 0), getWord(%container.position, 1), 784, mFloor(%count / 5) * 160 + 160);
		
		%swatch = new GuiSwatchCtrl()
		{
			extent = "160 160";
			position = %swatchPos;
			color = "0 0 0 0";
		};
		
		if(%name $= "No Trail")
			%imageName = "None";
		else
			%imageName = %name;
		
		
		%swatch.add(%swatch.objView = new GuiBitmapCtrl()
		{
			bitmap = "Add-Ons/Client_Jailbreak/res/trails/" @ %imageName;
			extent = "160 160";
			info = %info;
		});
		
		%tagX = 100;
		%tagXPos = 30;
		%isHat = 0;
		%tagYPos = 105;
		
		%container.add(%swatch);
	}
	else if(%type $= "Lights" || %type $= "Faces" || %type $= "Fists")
	{
		%tagX = 100;
		%tagXPos = 0;
		%tagYPos = 0;
		%extent = "100 100";
		%iconExtent = %extent;

		switch$ (%type)
		{
			case "Lights":
				%container = JBC_Menu_Lights;
			case "Faces":
				%container = JBC_Menu_Faces;
			case "Fists":
				%container = JBC_Menu_Fists;
				%iconExtent = "64 64";
				%tagX = 100;
				%iconX = 18 SPC 12;
		}
		%swatch = new GuiSwatchCtrl()
		{
			extent = %extent;
			color = "0 0 0 0";

			position = %container.getCount() * getWord(%extent, 0) SPC 0;
		};

		%swatch.icon = new GuiBitmapCtrl()
		{
			bitmap = %icon;
			extent = %iconExtent;
			position = %iconX SPC 0;
		};
		%swatch.add(%swatch.icon);

		%swatch.mouse = new GuiMouseEventCtrl(JBC_Shop_MouseEvent)
		{
			extent = %extent;
		};
		%swatch.add(%swatch.mouse);
		%swatch.mouse.swatch = %swatch;

		%container.add(%swatch);

		if(getWord(%swatch.position, 0) > getWord(%container.extent, 0))
			%container.resize(getWord(%container.position, 0), getWord(%container.position, 1), getWord(%swatch.position, 0) + getWord(%swatch.extent, 0) + 74, getWord(%container.extent, 1));
	}
	

	%nameBackColor = "60 105 148 220";
	if(%owned || %name $= "No Hat" || %name $= "No Trail")
		%nameBackColor = "27 94 32 180";

	if(%vip && !%owned)
		%nameBackColor = "156 39 176 120";
	
	%nameBack = new GuiBitmapCtrl()
	{
		position = %tagXPos SPC %tagYPos;
		extent = %tagX SPC "20";
		mColor = %nameBackColor;
		bitmap = "Add-Ons/Client_Jailbreak/res/nameback";
	};
	
	%nameTag = new GuiMLTextCtrl()
	{
		text = "<just:center><font:arial bold:18><color:ffffff>" @ %name;
		extent = %tagX SPC "20";
		position = "0 1";
	};
	%nameBack.add(%nameTag);
	%swatch.nameBack = %nameBack;
	%swatch.add(%nameBack);
	%swatch.tag = %nameTag;
	
	%mouse = new GuiMouseEventCtrl(JBC_Shop_MouseEvent)
	{
		extent = %swatch.extent;
		isHat = %isHat;
		info = %info;
		swatch = %swatch;
	};
	%swatch.add(%mouse);

	%info.swatch = %swatch;
	%swatch.info = %info;

	JBC_setHatSpinning(0);
}

function clientCmdJBC_setItemOwned(%name)
{
	if(!$JB::Online)
		return;
	
	if(!isObject(%obj = nameToID("JBC_ShopItem_" @ %name)))
		return;
	
	%obj.swatch.nameBack.mColor = "27 94 32 180";
	%obj.owned = 1;
}

function clientCmdJBC_setEquippedItems(%items)
{
	for(%i=0; %i < getWordCount($JBC::EquippedItems); %i++)
	{
		%curr = getWord($JBC::EquippedItems, %i);
		if(!isObject(%curr = nameToID("JBC_ShopItem_" @ %curr)))
			continue;

		%curr.equippedSwatch.setVisible(false);
	}

	for(%i=0; %i < getWordCount(%items); %i++)
	{
		%curr = getWord(%items, %i);
		if(!isObject(%curr = nameToID("JBC_ShopItem_" @ %curr)))
			continue;

		%curr.equippedSwatch.setVisible(true);
	}
	$JBC::EquippedItems = %items;
}

function clientCmdJBC_filterHats(%owned)
{
	if(%owned)
		alxPlay(JBC_Sound_Open);
	else
		alxPlay(JBC_Sound_Close);

	if(!$JB::Online)
		return;
	%hatCount = 0;
	for(%i=0; %i < JBC_Shop_HatsContainer.getCount(); %i++)
	{
		%swatch = JBC_Shop_HatsContainer.getObject(%i);
		if(%swatch.info.owned || !%owned || %swatch.info.name $= "No Hat")
		{
			%swatch.setVisible(true);
			%swatch.position = mFloor( ((%hatCount % 6) * 120) + 30) SPC mFloor(%hatCount / 6) * 130;
			%hatCount++;
		}
		else
			%swatch.setVisible(false);
	}
	if(!%owned)
		%hatCount = JBC_Shop_HatsContainer.getCount();
		
	JBC_Shop_HatsContainer.resize(getWord(JBC_Shop_HatsContainer.position, 0), getWord(JBC_Shop_HatsContainer.position, 1), 784, mFloor(%hatCount / 6) * 130 + 130);
}

function clientCmdJBC_setPreviewMode(%on)
{
	if(!$JB::Online)
		return;
	
	if(%on && $JB::PreviewingShop)
		return;
	
	if(serverConnection.getControlObject().getClassName() !$= "Camera")
		return;
	
	if(%on)
	{
		JBC_Menu_Tab_Shop_PreviewBack.setVisible(true);
		$JB::PreviewingShop = 1;
		JBC_Menu_Tab_Shop_Filter_Owned.setVisible(false);
		JBC_MenuWindow.tangoMoveTo(getWord(JBC_MenuWindow.position, 0) + 80 SPC getWord(JBC_MenuWindow.position, 1), 1000, "elastic");
		JBC_Menu_Content.color = "220 220 220 80";
		
		%hatOffset = 400;
		%hatRowCount = 3;
		
		
		%trailRowCount = 3;
		%trailOffset = 300;
	}
	else
	{
		commandToServer('donePreview');
		JBC_Menu_Tab_Shop_PreviewBack.setVisible(false);
		JBC_Menu_Tab_Shop_Filter_Owned.setVisible(true);
		$JB::PreviewingShop = 0;
		JBC_MenuWindow.tangoCenter(500, "elastic");
		JBC_Menu_Content.color = "220 220 220 240";
		
		%hatOffset = 30;
		%hatRowCount = 6;
		
		%trailOffset = -6;
		%trailRowCount = 5;
	}
		
	
	%hatCount = 0;
	for(%i=0; %i < JBC_Shop_HatsContainer.getCount(); %i++)
	{
		%swatch = JBC_Shop_HatsContainer.getObject(%i);
		if(%swatch.visible)
		{
			%swatch.position = mFloor( ((%hatCount % %hatRowCount) * 120) + %hatOffset) SPC mFloor(%hatCount / %hatRowCount) * 130;
			%hatCount++;
		}
	}
	JBC_Shop_HatsContainer.resize(getWord(JBC_Shop_HatsContainer.position, 0), getWord(JBC_Shop_HatsContainer.position, 1), 784, mFloor(%hatCount / %hatRowCount) * 130 + 130);
	
	%trailCount = 0;
	for(%i=0; %i < JBC_Shop_TrailsContainer.getCount(); %i++)
	{
		%swatch = JBC_Shop_TrailsContainer.getObject(%i);
		if(%swatch.visible)
		{
			%swatch.position = mFloor( ((%trailCount % %trailRowCount) * 160) + %trailOffset) SPC mFloor(%trailCount / %trailRowCount) * 160;
			%trailCount++;
		}
	}
	JBC_Shop_TrailsContainer.resize(getWord(JBC_Shop_TrailsContainer.position, 0), getWord(JBC_Shop_TrailsContainer.position, 1), 784, mFloor(%trailCount / %trailRowCount) * 160 + 130);
}
	
function clientCmdJBC_clearShop()
{
	if(!$JB::Online)
		return;
	if(!isObject(JBC_ShopGroup))
		return;
	
	JBC_ShopGroup.clear();
	JBC_Shop_TrailsContainer.clear();
	JBC_Shop_HatsContainer.clear();
	clientCmdJBC_clearShopBuffs();

	JBC_Menu_Lights.clear();
	JBC_Menu_Faces.clear();
	JBC_Menu_Fists.clear();
	
	for(%i = JBC_Menu_Tab_Staff_List.getCount() - 1; %i > 0; %i--)
		JBC_Menu_Tab_Staff_List.getObject(%i).delete();
	
	JBC_Shop_HatsContainer.resize(getWord(JBC_Shop_HatsContainer.position, 0), getWord(JBC_Shop_HatsContainer.position, 1), 565, 0);
}

function clientCmdJBC_setShopMoney(%amt)
{
	if(!$JB::Online)
		return;
	JBC_Menu_ShopMoney.setText("\c6" @ %amt);
}

function GuiObjectView::spinLoop(%this)
{
	cancel(%this.spinLoop);
	%this.setCameraRot(0, 0, %this.rot += 0.03);
	
	if(%this.hasMouseOver)
		%speed = 15;
	else
		%speed = 50;
	
	%this.spinLoop = %this.schedule(%speed, "spinLoop");
}

function JBC_setHatSpinning(%bool)
{
	if(!$JB::Pref["HatSpinning"] && %bool)
		return;

	for(%i=0; %i < JBC_Shop_HatsContainer.getCount(); %i++)
	{
		%swatch = JBC_Shop_HatsContainer.getObject(%i);
		if(!isObject(%swatch.objView))
			continue;
		
		if(%bool)
			%swatch.objView.spinLoop();
		else
			cancel(%swatch.objView.spinLoop);
	}
}

function clientCmdJBC_clearShopBuffs()
{
	if(!$JB::Online)
		return;
	
	JBC_Menu_RoundBuffs.clear();
	JBC_Menu_RoundBuffs.numBuffs = 0;
	JBC_Menu_PlayerBuffs.clear();
	JBC_Menu_PlayerBuffs.numBuffs = 0;
}

function clientCmdJBC_addShopBuff(%type, %buff)
{
	if(!$JB::Online)
		return;
	
	if(%type $= "Round")
		%ctrl = JBC_Menu_RoundBuffs;
	else if(%type $= "Player")
		%ctrl = JBC_Menu_PlayerBuffs;
	
	%ctrl.addRow(%ctrl.numBuffs++, %buff);
}

function JBC_buyBuff(%type)
{
	if(%type $= "Round")
		%ctrl = JBC_Menu_RoundBuffs;
	else if(%type $= "Player")
		%ctrl = JBC_Menu_PlayerBuffs;

	commandToServer('buy', stripMLControlChars(getWord(%ctrl.getRowTextById(%ctrl.getSelectedID()), 0)));
}

function clientCmdJBC_setStat(%stat, %value)
{
	if(!$JB::Online)
		return;
	
	%label = nameToID("JBC_Menu_Profile_" @ %stat);
	if(!isObject(%label))
		return;
	
	%label.setText("\c8" @ %value);
}

function clientCmdJBC_boughtItem(%item)
{
	alxPlay(JBC_Sound_Money);
}

// Mouse event controls
function JBC_Shop_MouseEvent::onMouseEnter(%this)
{	
	%this.swatch.color = "180 180 180 140";
	%this.swatch.objView.hasMouseOver = true;
	if(getWord(%this.info.name, 0) !$= "No")
	{
		if(%this.info.price == 0)
			%price = "<color:ffffff>Special Item";
		else
			%price =  "<color:ffffff>$" @ NumberToString(%this.info.price);
		
		%this.swatch.tag.setText("<just:center><font:arial bold:18>" @ %price);
	}
}

function JBC_Shop_MouseEvent::onMouseLeave(%this)
{
	%this.swatch.color = "0 0 0 0";
	%this.swatch.objView.hasMouseOver = false;
	%this.swatch.tag.setText("<just:center><font:arial bold:18><color:ffffff>" @ %this.info.name);
}

function JBC_Shop_MouseEvent::onRightMouseDown(%this, %mod, %point, %count)
{
	if(%mod == $EventModifier::LSHIFT)
	{
		commandToServer('preview', %this.info.name, 1, 1);
		clientCmdJBC_setPreviewMode(1);
		return;
	}
	
	if(%this.info.name $= "No Hat")
	{
		commandToServer('unEquip', "hat2");
		%label = %this.swatch.tag;
		%label.schedule(1500, "setText", "<just:center><font:arial bold:18><color:ffffff>" @ %this.info.name);
		%label.setText("<just:center><font:arial bold:18><color:ffff00>Unequipped");
	} 
	 
	if(%this.info.owned && %this.isHat)
	{
		%label = %this.swatch.tag;
		%label.schedule(1500, "setText", "<just:center><font:arial bold:18><color:ffffff>" @ %this.info.name);
		%label.setText("<just:center><font:arial bold:18><color:ffff00>Equipped");
		commandToServer('hat2', %this.info.name);
	}
	if(%this.info.owned)
		alxPlay(JBC_Sound_Open);
}

function JBC_Shop_MouseEvent::onMouseDown(%this, %mod, %point, %count)
{	
	if(%mod == $EventModifier::LSHIFT)
	{
		commandToServer('preview', %this.info.name, 0, 1);
		clientCmdJBC_setPreviewMode(1);
		return;
	}

	if(!%this.info.owned)
	{
		if(getWord(%this.info.name, 0) $= "No")
		{
			alxPlay(JBC_Sound_Open);
			%this.swatch.tag.schedule(1500, "setText", "<just:center><font:arial bold:18><color:ffffff>" @ %this.info.name);
			%this.swatch.tag.setText("<just:center><font:arial bold:18><color:ffff00>Unequipped");
		}

		if(%this.info.name $= "No Trail")
		{
			commandToServer('trail', "none");
			return;
		}
		else if(%this.info.name $= "No Hat")
		{
			commandToServer('unEquip', "hat");
			return;
		}
		else if(%this.info.name $= "No Face")
		{
			commandToServer('face', "");
			return;
		}
		else if(%this.info.name $= "No Fist")
		{
			commandToServer('fist', "");
			return;
		}
		
		$JB::itemSelection = %this.info.name;
		commandToServer('setBuy', %this.info.name);
		alxPlay(JBC_Sound_Buy);

		if(%this.info.price == 0)
			commandToServer('buyYes');
		else
			clientCmdmessageBoxYesNo("Crown's Jailbreak", "<font:arial bold:16>Would you like to buy" SPC %this.info.name SPC "for $" @ NumberToString(%this.info.price) @ "?", 'buyYes');
	}
	else
	{
		%label = %this.swatch.tag;
		%label.schedule(1500, "setText", "<just:center><font:arial bold:18><color:ffffff>" @ %this.info.name);
		%label.setText("<just:center><font:arial bold:18><color:CDDC39>Equipped");
		commandToServer('equip', %this.info.name);
		alxPlay(JBC_Sound_Open);
	}
}

function GuiWindowCtrl::center(%this)
{
	%res = getRes();
	%this.position = mFloor(getWord(%res, 0) / 2) - mFloor(getWord(%this.extent, 0) / 2) SPC mFloor(getWord(%res, 1) / 2) - mFloor(getWord(%this.extent, 1) / 2); 
}

function JBC_DisplayHelp()
{
	clientCmdmessageBoxOK("Crown's Jailbreak", "You can open up the Jailbreak menu at any time by pressing your B (brick menu) key.<br><br>All of the pieces of the HUD can be moved if you press M and drag them.<br><br>If you click on an item in the shop it equips, rightclick for second slot.<br><br>If you hold shift before you click or rightclick an item you are able to preview it.");
}

function clientCmdJBC_setMenuButtonVisible(%bool)
{
	JBC_MenuButton.delete();
	if(!isObject(JBC_MenuButton))
	{
		new GuiBitmapButtonCtrl(JBC_MenuButton)
		{
			profile = "JBC_TabTextProfile";
			extent = "100 22";
			mColor = "60 105 148 180";
			text = "\c6Open Menu (" @ strupr(getWord(moveMap.getBinding("openBSD"), 1)) @ ")";
			bitmap = "Add-Ons/Client_Jailbreak/res/rButton";
			visible = false;
			command = "JBC_toggleMenu(1);";
			position = getWord(getRes(), 0) - 200 SPC getWord(getRes(), 1) - 22;
		};
		NewChatHUD.add(JBC_MenuButton);
	}
	if(%bool)
		JBC_MenuButton.setVisible(true);
	else
		JBC_MenuButton.setVisible(false);
}

// Visolator
//Convert numbers from 1000 to 1,000; 100000 to 100,000, etc
function NumberToString(%num)
{
    if(strLen(%num) <= 3)
        return %num;
 
    if(strPos(%num, ".") > 0)
    {
        %dec = getSubStr(%num, strPos(%num, "."), strLen(%num)-1);
        %num = getSubStr(%num, 0, strPos(%num, "."));
    }
 
    %len = strLen(%num);
    %count = %len / 3;
    %left = %len % 3;
    while(%i < %count)
    {
        %i++;
 
        %l = mClampF(%len - 3 * %i, 0, %len-1);
        if(%nNum $= "")
            %nNum = getSubStr(%num, %l, 3);
        else
        {
            if(%left > 0 && %i == mFloor(%count)+1)
                %nNum = getSubStr(%num, %l, %left) @ "," @ %nNum;
            else
                %nNum = getSubStr(%num, %l, 3) @ "," @ %nNum;
        }
    }
 
    return %nNum @ %dec;
}
