if(!isObject(JBC_PlayerListSorter))
	new GuiTextListCtrl(JBC_PlayerListSorter);

function clientCmdJBC_showPlayerlist(%on)
{
	if(!$JB::Online)
		return;
	
	if(%on $= "")
	{
		if(!JBC_PlayerList.isAwake())
			canvas.pushDialog(JBC_PlayerList);
		else
			canvas.popDialog(JBC_PlayerList);
		return;
	}
	
	if(%on == 1)
		canvas.pushDialog(JBC_PlayerList);
	else if(%on == 0)
		canvas.popDialog(JBC_PlayerList);
}

function JBC_PlayerList::onWake(%this)
{
	if($JB::Pref["DisplayedHelpF2"] != 1)
	{
		$JB::Pref["DisplayedHelpF2"] = 1;
		export("$JB::Pref*", "config/client/jailbreak.cs"); 

		clientCmdmessageBoxOK("Crown's Jailbreak", "<sPush><font:arial bold:22>This is the Jailbreak playerlist, there are a couple things you should know:<sPop><br><br><br>You can click any player to view more info about them, or to rate them.<br><br>If you click the Crown at the top of the list, you can sort by team again if you've unsorted.<br><br>If you rightclick the Crown, it will close all open player information boxes.");
	}

	JBC_PlayerList_Order();

	commandToServer('JB_openPlayerList');
	JBC_refreshPlayerList();	
}

function JBC_PlayerList::onSleep(%this)
{
	commandToServer('JB_closePlayerList');
	cancel($JB::TimePlayedTick);
}

function JBC_PlayerList_TimeplayedTick()
{
	cancel($JB::TimePlayedTick);

	for(%i=0; %i < JBC_PlayerList_Swatch.getCount(); %i++)
	{
		%swatch = JBC_Playerlist_Swatch.getObject(%i);
		if(%swatch.isOpen)
		{
			%swatch.info.timePlayedLabel.setText("\c8" SPC getTimeString(%swatch.info.timePlayedLabel.timePlayed++));
		}
	}
	$JB::TimePlayedTick = schedule(1000, 0, "JBC_PlayerList_TimeplayedTick");
}

function JBC_refreshPlayerList()
{
	for(%i=0; %i < JBC_PlayerList_Swatch.getCount(); %i++)
	{
		%swatch = JBC_Playerlist_Swatch.getObject(%i);
		if(%swatch.isOpen)
			commandToServer('JBC_requestPlayerInfo', stripMLControlChars(%swatch.IDLabel.getText()));
	}
	JBC_PlayerList_TimeplayedTick();
}

function clientCmdJBC_updatePlayer(%blid, %score)
{
	if(!$JB::Online)
		return;
	if(!isObject(%obj = nameToID("JBC_Player_" @ %blid)))
		return;
	
	%obj.score.setText("<just:center><font:arial bold:18><color:eceff1>$" @ NumberToString(%score));
	JBC_PlayerListSorter.setRowById(%blid, setField(JBC_PlayerListSorter.getRowTextById(%blid), 3, %score));
	if($JB::lastSort $= "Money")
		JBC_PlayerList_Sort("Money");
}

function clientCmdJBC_removePlayer(%blid)
{
	if(!$JB::Online)
		return;
	if(isObject(%obj = nameToID("JBC_Player_" @ %blid)))
	{
		JBC_PlayerListSorter.removeRowByID(%blid);
		%obj.delete();
	}
	JBC_PlayerList_Sort($JB::lastSort);
}

function clientCmdJBC_addPlayer(%blid, %name, %team, %color, %score, %icon, %rank)
{
	if(!$JB::Online)
		return;
	if(%color $= "")
		%color = "757575";
	
	if(isObject(%obj = nameToID("JBC_Player_" @ %blid)))
	{
		JBC_PlayerListSorter.removeRowByID(%blid);
		%obj.delete();
	}
	
	%background = new GuiSwatchCtrl("JBC_Player_" @ %blid)
	{
		extent = "696 34";
		color = JBC_hexToRGB(%color) SPC 220;
		position = "2 2";
		blid = %blid;
	};
	
	%nameLabel = new guiMLTextCtrl()
	{
		text = "<just:left><font:arial bold:18><color:eceff1>" @ %name;
		extent = "270 10";
		position = "82 7";
	};

	%pingLabel = new guiMLTextCtrl("JBC_PlayerListPing_" @ %blid)
	{
		text = "<just:center><font:arial bold:18><color:eceff1>0";
		extent = "90 10";
		position = "492 7";
	};
	%background.add(%pingLabel);

	%background.ratingLabel = new GuiBitmapCtrl("JBC_PlayerListRating_" @ %blid)
	{
		extent = "16 16";
		position = "670 9";
		visible = false;
		bitmap = "Add-Ons/Client_Jailbreak/res/icon/none";
	};
	%background.add(%background.ratingLabel);

	if(%score $= "")
		%score = 0;
	
	%scoreLabel = new guiMLTextCtrl()
	{
		text = "<just:center><font:arial bold:18><color:eceff1>$" @ NumberToString(%score);
		extent = "200 10";
		position = "349 7";
	};

	%button = new GuiMouseEventCtrl(JBC_Playerlist_TitleMouse)
	{
		swatch = %background;
		blid = %blid;
		extent = "678 34";
	};
	%button.background = %background;
	
	%iconPath = "Add-ons/Client_Jailbreak/res/icon/" @ %icon;
	if(!isFile(%iconPath @ ".png"))
		%iconPath = "Add-ons/System_BlocklandGlass/image/icon/" @ %icon;

	if(%icon $= "" || !isfile(%iconPath @ ".png"))
		%iconPath = "Add-Ons/Client_Jailbreak/res/icon/none";
	
	%iconLabel = new GuiBitmapCtrl()
	{
		position = "27 8";
		extent = "16 16";
		bitmap = %iconPath;
	};

	%idLabel = new guiMLTextCtrl()
	{
		text = "<just:center><font:arial bold:18><color:eceff1>" @ %blid;
		extent = "200 10";
		position = "528 7";
	};
	%background.idLabel = %idLabel;
	%background.add(%idLabel);
	
	%background.icon = %iconLabel;
	%background.name = %nameLabel;
	%background.score = %scoreLabel;
	%background.button = %button;
	%background.teamColor = %color;
	
	%background.add(%iconLabel);
	%background.add(%nameLabel);
	%background.add(%scoreLabel);
	%background.add(%button);
	
	JBC_PlayerList_Swatch.add(%background);
	JBC_PlayerListSorter.addRow(%blid, %blid TAB %name TAB %team TAB %score TAB %rank);
	JBC_PlayerList_Sort($JB::lastSort);
}

function clientCmdJBC_receivePlayerInfo(%blid, %rank, %timeplayed, %team, %ratings)
{
	if(!$JB::Online)
		return;
	if(!isObject(%obj = nameToID("JBC_PlayerInfo_" @ %blid)))
		return;

	%obj.rankLabel.setText("\c9" SPC %rank);
	%obj.timePlayedLabel.timePlayed = %timePlayed;
	%obj.timePlayedLabel.setText("\c8" SPC getTimestring(%timePlayed));
	%obj.teamLabel.setText("\c8" SPC %team);

	%main = nameToID("JBC_Player_" @ %blid);

	%rateCount = 0;
	for(%i=0; %i < %main.getCount(); %i++)
	{
		%rateLabel = %main.getObject(%i);
		if(%rateLabel.getName() $= "JBC_PlayerRating")
		{
			%rateLabel.rateLabel.setText("\c7" @ getWord(%ratings, %rateCount));
			%rateCount++;
		}
	}
}

function clientCmdJBC_viewPlayerInfo(%blid)
{
	if(!$JB::Online)
		return;
	if(!isObject(%swatch = nameToID("JBC_Player_" @ %blid)))
		return;
	
	if(%swatch.isOpen)
	{
		alxPlay(JBC_Sound_Close);

		%swatch.isOpen = false;
		%swatch.extent = "696 36";

		if(isObject(%info = nameToID("JBC_PlayerInfo_" @ %blid)))
			%info.setVisible(false);
	}
	else
	{
		alxPlay(JBC_Sound_Open);

		%swatch.isOpen = true;
		%swatch.extent = "696 100";
		
		if(!isObject(%info = nameToID("JBC_PlayerInfo_" @ %blid)))
		{
			%info = new GuiSwatchCtrl("JBC_PlayerInfo_" @ %blid)
			{
				extent = "688 64";
				position = "4 30";
				color = "220 220 220 220";
			};
			%swatch.info = %info;

			// Labels
			%info.add(new GuiTextCtrl()
			{
				profile = JBC_InfoTextProfile;
				extent = "100 20";
				text = "\c7Rank:";
				position = "14 2";
			});


			%info.add(new GuiTextCtrl()
			{
				profile = JBC_InfoTextProfile;
				extent = "100 20";
				text = "\c7Played:";
				position = "14 20";
			});


			%info.add(new GuiTextCtrl()
			{
				profile = JBC_InfoTextProfile;
				extent = "100 20";
				text = "\c7Team:";
				position = "14 38";
			});
			// Information
			%info.rankLabel = new GuiTextCtrl()
			{
				profile = JBC_InfoTextProfile;
				extent = "100 20";
				text = "";
				position = "110 2";
			};
			%info.add(%info.rankLabel);

			%info.timePlayedLabel = new GuiTextCtrl()
			{
				profile = JBC_InfoTextProfile;
				extent = "100 20";
				text = "";
				position = "110 20";
			};
			%info.add(%info.timePlayedLabel);

			%info.teamLabel = new GuiTextCtrl()
			{
				profile = JBC_InfoTextProfile;
				extent = "100 20";
				text = "";
				position = "110 38";
			};
			%info.add(%info.teamLabel);

			%swatch.add(%info);

			%swatch.add(JBC_createRating(%blid, "smile", "505 40"));
			%swatch.add(JBC_createRating(%blid, "heart", "535 40"));
			%swatch.add(JBC_createRating(%blid, "dumb", "565 40"));
			%swatch.add(JBC_createRating(%blid, "star", "595 40"));
			%swatch.add(JBC_createRating(%blid, "artistic", "625 40"));
			%swatch.add(JBC_createRating(%blid, "rainbow", "655 40"));

			%swatch.add(new GuiBitmapButtonCtrl() 
			{
				profile = "JBC_TabTextProfile";
				extent = "65 20";
				bitmap = "Add-Ons/Client_Jailbreak/res/button";
				text = "\c6Lookup";
				position = "240 52";
				command = "clientCmdJBC_lookup(setField(\"\", 1," @ %blid @ "));canvas.pushDialog(JBC_Menu);JBC_setTab(\"Profile\");";
				mColor = "220 220 220 160";
			});

			%swatch.add(new GuiBitmapButtonCtrl() 
			{
				profile = "JBC_TabTextProfile";
				extent = "65 20";
				bitmap = "Add-Ons/Client_Jailbreak/res/button";
				text = "\c6Copy ID";
				position = "320 52";
				command = "setClipboard(" @ %blid @ ");";
				mColor = "220 220 220 160";
			});
			if(%blid != getNumKeyID())
			{
				%swatch.add(new GuiBitmapButtonCtrl() 
				{
					profile = "JBC_TabTextProfile";
					extent = "65 20";
					bitmap = "Add-Ons/Client_Jailbreak/res/button";
					text = "\c6Message";
					position = "400 52";
					command = "JBC_glassMessage(" @ %blid @ ");";
					mColor = "220 220 220 160";
				});
			}
		}
		else
			%info.setVisible(true);
	}
	JBC_PlayerList_Order();

	commandToServer('JBC_requestPlayerInfo', %blid);
}

function JBC_glassMessage(%blid)
{
	// Glass protects you from doing this too, so don't bother removing it here.
	if(%blid == getNumKeyID())
		return;

	if(!isObject(Glass))
	{
		clientCmdmessageBoxOK("Crown's Jailbreak", "Looks like you don't have <a:www.blocklandglass.com>Blockland Glass</a> installed. Get it to message friends and find add-ons!");
		return;
	}

	%found = 0;
	for(%i = 0; %i < GlassLiveUsers.getCount(); %i++) 
	{
  		%user = GlassLiveUsers.getObject(%i);
  		if(strStr(strLwr(%user.username), strLwr(%search)) >= 0 || strStr(%user.blid, %search) >= 0)
     	{
     		if(%user.blid $= %blid)
     		{
     			%found = 1;
     			break;
     		}
     	}
    }

    if(!%found)
    {
    	clientCmdmessageBoxOK("Crown's Jailbreak", "This player is not available for chat. They are either not online, or do not have Blockland Glass installed.");
    	return;
    }

	GlassOverlay.open(); 
	GlassLive::openDirectMessage(%blid); 
	if(isObject(GlassLiveUser::getFromBlid(%blid).getMessageGui()))
		GlassLiveUser::getFromBlid(%blid).getMessageGui().forceCenter();
}

function JBC_createRating(%blid, %rating, %position)
{
	%swatch = new GuiSwatchCtrl(JBC_PlayerRating)
	{
		extent = "24 40";
		color = "190 190 190 220";
		position = %position;
	};
	%swatch.add(new GuiBitmapCtrl()
	{
		bitmap = "Add-Ons/Client_Jailbreak/res/icon/" @ %rating;
		extent = "16 16";
		position = "4 2";
	});

	%swatch.rateLabel = new GuiTextCtrl()
	{
		profile = JBC_SmallInfoTextProfile;
		extent = "24 10";
		text = "\c70";
		position = "0 20";
		minExtent = "24 10";
	};
	%swatch.add(%swatch.rateLabel);
	
	%swatch.add(new GuiButtonBaseCtrl()
	{
		extent = %swatch.extent;
		command = "commandToServer('rate', " @ %blid @ "," @ %rating @ ");alxPlay(JBC_Sound_Pop);";

	});

	return %swatch;
}

function clientCmdJBC_clearPlayerList()
{
	if(!$JB::Online)
		return;
	
	JBC_PlayerListSorter.clear();
	JBC_PlayerList_Swatch.clear();
}

function clientCmdJBC_setPlayerlistBottom(%text)
{
	if(!$JB::Online)
		return;
	JBC_Playerlist_Bottom.setText(%text);
}

function JBC_PlayerList_Sort(%by)
{
	if(%by $= "ping")
		return;

	if(%by $= "")
		JBC_PlayerListSorter.sort(2, 1);
	else if(%by $= "name")
		JBC_PlayerListSorter.sort(1, 1);
	else if(%by $= "blid")
		JBC_PlayerListSorter.sortNumerical(0, 1);
	else if(%by $= "money")
		JBC_PlayerListSorter.sortNumerical(3, 0);
	else if(%by $= "rank")
		JBC_PlayerListSorter.sort(4, 0);
		
	schedule(100, 0, "JBC_PlayerList_Order");
	$JB::lastSort = %by;
}

function JBC_PlayerList_Order()
{
	if(!JBC_PlayerListWindow.isAwake()) 
		return; 

	%totalY = 2;
	for(%i = 0; %i < JBC_PlayerListSorter.rowCount(); %i++)
	{
		%row = JBC_PlayerListSorter.getRowText(%i);
		%swatch = nameToID("JBC_Player_" @ getField(%row, 0));
		if(!isObject(%swatch))
			continue;
		
		%swatch.resize(2, %totalY, getWord(%swatch.extent, 0), getWord(%swatch.extent, 1));
		%totalY += getWord(%swatch.extent, 1) + 2;
	} 
	JBC_Playerlist_Swatch.resize(getWord(JBC_Playerlist_Swatch.position, 0), getWord(JBC_Playerlist_Swatch.position, 1), 700, %totalY);

	if(%totalY + 100 > getWord(getRes(), 1))
		%totalY = getWord(getRes(), 1) - 100;

	JBC_PlayerlistWindow.resize(getWord(JBC_PlayerlistWindow.position, 0), getWord(JBC_PlayerlistWindow.position, 1), getWord(JBC_PlayerlistWindow.extent, 0), %totalY + 100);
	JBC_Playerlist_BottomBar.resize(0, getWord(JBC_PlayerlistWindow.extent, 1) - 17, getWord(JBC_Playerlist_BottomBar.extent, 0), getWord(JBC_Playerlist_BottomBar.extent, 1));
	JBC_Playerlist_Scroll.resize(getWord(JBC_Playerlist_Scroll.position, 0), getWord(JBC_Playerlist_Scroll.position, 1), getWord(JBC_Playerlist_Scroll.extent, 0), getWord(JBC_Playerlist_BottomBar.position, 1) - 85);
	JBC_Playerlist_Background.resize(0, 80, getWord(JBC_Playerlist_Scroll.extent, 0), getWord(JBC_Playerlist_BottomBar.position, 1) - 80);

	JBC_PlayerListWindow.tangoCenter("500", "elastic");
}

function clientCmdJBC_receivePingInfo(%pings)
{
	%ct = getRecordCount(%pings);
	for(%i=0; %i < %ct; %i++)
	{
		%data = getRecord(%pings, %i);
		%id = getField(%data, 0);
		%ping = getField(%data, 1);
		if(isObject(%ctrl = nameToID("JBC_PlayerListPing_" @ %id)))
		{
			%ctrl.setText("<just:center><font:arial bold:18><color:eceff1>" @ %ping);
		}
	}
}

function JBC_PlayerList_Mouse::onMouseEnter(%this)
{
	JBC_PlayerList_Crown.setBitmap("Add-Ons/Client_Jailbreak/res/largecrowns");
}

function JBC_PlayerList_Mouse::onMouseLeave(%this)
{
	JBC_PlayerList_Crown.setBitmap("Add-Ons/Client_Jailbreak/res/largecrown");
}

function JBC_PlayerList_Mouse::onMouseDown(%this)
{
	JBC_PlayerList_Sort();
}

function JBC_PlayerList_Mouse::onRightMouseDown(%this)
{
	for(%i=0; %i < JBC_PlayerList_Swatch.getCount(); %i++)
	{
		%swatch = JBC_Playerlist_Swatch.getObject(%i);
		if(%swatch.isOpen)
			clientCmdJBC_viewPlayerInfo(stripMLControlChars(%swatch.IDLabel.getText()));
	}
}

function JBC_Playerlist_TitleMouse::onMouseDown(%this)
{
	clientCmdJBC_viewPlayerInfo(%this.blid);
}

function JBC_Playerlist_TitleMouse::onMouseEnter(%this)
{
	%this.mouseOver = 1;
	%this.background.oldColor = %this.background.color;
	%this.background.color = vectorAdd(%this.background.color, "0 0 0 -12");

	%ctrl = nameToID("JBC_PlayerListRating_" @ %this.background.blid);
	if(%ctrl.bitmap !$= "Add-Ons/Client_Jailbreak/res/icon/none")
		%ctrl.setVisible(true);
	commandToServer('requestRating', %this.background.blid);
}

function JBC_Playerlist_TitleMouse::onMouseLeave(%this)
{
	%this.mouseOver = 0;
	%this.background.color = %this.background.oldColor;
	%this.background.ratingLabel.setVisible(false);
}

function clientCmdJBC_recievePlayerRating(%blid, %rating)
{
	%main = nameToID("JBC_Player_" @ %blid);
	if(!isObject(%main))
		return;

	if(!%main.button.mouseOver)
		return;

	%ctrl = nameToID("JBC_PlayerListRating_" @ %blid);
	%ctrl.setBitmap("Add-Ons/Client_Jailbreak/res/icon/" @ %rating);
	%ctrl.setVisible(true);
}

function JBC_hexToRGB(%hex)
{
   for(%i = 0; %i < 3; %i++)
      eval("%color[%i] = 0x" @ getSubStr(%hex, %i * 2, 2) @ ";");
   return %color0 SPC %color1 SPC %color2;
}

function addFakes()
{
	clientCmdJBC_clearPlayerList();
	clientCmdJBC_addPlayer(0, "Bob Smith", "Guards", "3f51b5", "23", "");
	clientCmdJBC_addPlayer(1, "Josh Nest", "Guards", "3f51b5", "5422400", "");
	clientCmdJBC_addPlayer(2, "Jeff Lamper", "Guards", "3f51b5", "2312", "");
	clientCmdJBC_addPlayer(3, "Jedd Davis", "Prisoners", "e65100", "2323200", "");
	clientCmdJBC_addPlayer(4, "Larry Smith", "Prisoners", "e65100", "7571", "");
	clientCmdJBC_addPlayer(5, "Darren Bobsled", "Prisoners", "e65100", "32551", "");
	clientCmdJBC_addPlayer(6, "Curt Brutis", "Prisoners", "e65100", "3253", "");
	clientCmdJBC_addPlayer(7, "Todd Packer", "Prisoners", "e65100", "12512", "");
}
