// Make sure every setting has a value and if it doesn't set it to the default.

if(isFile("config/client/jailbreak.cs"))
	exec("config/client/jailbreak.cs");
	
if($JB::Pref["HUD"] $= "")
	$JB::Pref["HUD"] = 1;

if($JB::Pref["Playerlist"] $= "")
	$JB::Pref["Playerlist"] = 1;

if($JB::Pref["MessageBoxes"] $= "")
	$JB::Pref["MessageBoxes"] = 1;

if($JB::Pref["Shapenames"] $= "")
	$JB::Pref["Shapenames"] = 1;

if($JB::Pref["AlwaysShapenames"] $= "")
	$JB::Pref["AlwaysShapenames"] = 0;

if($JB::Pref["DisplayedHelp"] $= "")
	$JB::Pref["DisplayedHelp"] = 0;

if($JB::Pref["AlternativeFont"] $= "")
	$JB::Pref["AlternativeFont"] = 0;

if($JB::Pref["DisableAnimations"] $= "")
{
	// I'm not sure if this happens on all Macs, but during testing animations would not work on my Macbook.
	if(isMacintosh())
		$JB::Pref["DisableAnimations"] = 1;
	else
		$JB::Pref["DisableAnimations"] = 0;
}

if($JB::Pref["HideToolBar"] $= "")
	$JB::Pref["HideToolBar"] = 1;

if($JB::Pref["DisplayStats"] $= "")
	$JB::Pref["DisplayStats"] = 0;

if($JB::Pref["AlwaysShowStats"] $= "")
	$JB::Pref["AlwaysShowStats"] = 1;

if($JB::Pref["HatSpinning"] $= "")
	$JB::Pref["HatSpinning"] = 1;


export("$JB::Pref*", "config/client/jailbreak.cs"); 

// Handle specific settings
function clientCmdJBC_receiveBlocklist(%list)
{
	if(!$JB::Online)
		return;
	
	JBC_Menu_Tab_Settings_BlockList.clear();
	for(%i=0; %i < getWordCount(%list); %i++)
	{
		%id = getWord(%list, %i);
		JBC_Menu_Tab_Settings_BlockList.addRow(%id, "\c0" @ %id);
	}
}

function clientCmdJBC_sendSetting(%setting)
{
	commandToServer('sendSetting', %setting, $JB::Pref[%setting]);
}

function clientCmdJBC_handleSetting(%setting)
{
	if(!$JB::Online)
		return;
	
	$JB::Pref[%setting] = !$JB::Pref[%setting];
	export("$JB::Pref*", "config/client/jailbreak.cs"); 
	clientCmdJBC_callbackSetting(%setting);
}
 
function JBC_sendBlockInput()
{
	commandToServer('block', JBC_Menu_Tab_Settings_BlockInput.getValue());
	JBC_Menu_Tab_Settings_BlockInput.setValue("");
}
 
function clientCmdJBC_callbackSetting(%setting)
{
	if(!$JB::Online)
		return;
	
	if(%setting $= "HUD")
	{
		cancel(PlayGui.unJailbreakSched);
		if(!$JB::Pref["HUD"])
		{	
			deactivatePackage(JBC_weaponSwitcher);
			
			commandToServer('SetUsingHUD', 0);
			clientCmdJBC_HUD_cleanup();
			PlayGui.unJailbreakSched = PlayGui.schedule(500, "createToolHUD");
		}
		else
		{
			clientCmdJBC_hideDefaultHUD();
			commandToServer('SetUsingHUD', 1);
			activatePackage(JBC_weaponSwitcher);
		}
	}
	
	else if(%setting $= "Shapenames")
	{
		if($JB::Pref["Shapenames"])
			PlayGui_ShapeNameHud.setProfile(JBC_ShapeNameProfile);
		else
			PlayGui_ShapeNameHud.setProfile(BlockChatTextProfile);
	}

	else if(%setting $= "AlternativeFont")
	{
		if($JB::Pref["AlternativeFont"])
		{
			JBC_LargeHUDLabelText.fontType = "arial bold";
			JBC_LargeHUDLabelText.fontSize = 23;
		}
		else
		{
			JBC_LargeHUDLabelText.fontType = "helvetica";
			JBC_LargeHUDLabelText.fontSize = 23;
		}
		JBC_LargeHUDLabelText.updateFont();
	}

	else if(%setting $= "DisplayStats")
	{
		if(!$JB::Pref["DisplayStats"])
			clientCmdJBC_PlayGui_DisplayInfo(false);
		else
			clientCmdJBC_PlayGui_DisplayInfo(true);
	}
	else if(%setting $= "HatSpinning")
	{
		if(!$JB::Pref["JBC_setHatSpinning"])
			JBC_setHatSpinning(1);
		else
			JBC_setHatSpinning(0);
	}
}

function JBC_Menu_Tab_Settings::onWake(%this)
{
	if(!isFile("config/client/jailbreak.cs"))
	{
		warn("No jailbreak settings file found!");
		return;
	}
	
	%fo = new FileObject();
	%fo.openForRead("config/client/jailbreak.cs");
	while(!%fo.isEOF())
	{
		%line = %fo.readLine();
		
		%setting = strReplace(getWord(%line, 0), "$JB::Pref", "");
		%value = strReplace(getWord(%line, 2), ";", "");
		if(%setting $= "DisplayedHelp" && %value == 0)
		{
			JBC_DisplayHelp();
			$JB::Pref["DisplayedHelp"] = 1;
		}
			
		
		if(isObject(%ctrl = nameToID("JBC_Setting_" @ %setting)))
			%ctrl.setValue(%value);
	}
	
	%fo.close();
	%fo.delete();
	
	export("$JB::Pref*", "config/client/jailbreak.cs"); 
}