
///////////////////
// Weapon Switcher
///////////////////
function clientCmdJBC_createWeaponSwitcher()
{
	if(!$JB::Online)
		return;
	
	if(isObject(JBC_weaponSwitcher))
		JBC_weaponSwitcher.delete();
	
	%swatch = new GuiSwatchCtrl(JBC_weaponSwitcher)
	{
		toggled = 0;
		position = mFloor(getWord(getRes(), 0) / 2) - 165 SPC getWord(getRes(), 1) + 10;
		extent = "328 82";
		color = "0 0 0 0";
	};
	
	%topBar = new GuiSwatchCtrl()
	{
		color = "0 35 50 186";
		extent = "328 18";
	};
	
	%selectedItem = new GuiBitmapCtrl(JBC_weaponSwitcher_active)
	{
		bitmap = "base/client/ui/brickicons/brickIconActive";
		extent = "64 64";
		visible = 0;
	};
	
	%itemLabel = new GuiMLTextCtrl(JBC_weaponSwitcher_label)
	{
		extent = "328 20";
		position = "0 1";
	};
	
	%ammoLabel = new GuiMLTextCtrl(JBC_weaponSwitcher_ammoLabel)
	{
		extent = "100 20";
		position = "228 1";
	};
	
	%swatch.add(%topBar);
	%swatch.add(%selectedItem);
	%swatch.add(%itemLabel);
	%swatch.add(%ammoLabel);

	for(%i=0; %i < 5; %i++)
	{
		%container = new GuiSwatchCtrl("JBC_weaponSwitcher_item" @ %i)
		{
			position = %i * 64 + %i * 2 SPC 18;
			extent = "64 64";
			color = "0 0 0 64";
		};
		%bitmap = new GuiBitmapCtrl()
		{
			bitmap = "base/data/shapes/blank";
			extent = "64 64";
		};
		%container.icon = %bitmap;
		%container.add(%bitmap);
		%swatch.add(%container);
	}
	NewChatHUD.add(JBC_weaponSwitcher);
	clientCmdJBC_weapons_hide();
}

function JBC_weaponSwitcher::Toggle(%this)
{
	%x = getWord(getRes(), 0);
	%y = getWord(getRes(), 1);
	
	if(%this.toggled)
	{
		%x = %x / 2 - 168;
		if($JB::Pref["HideToolBar"])
			%this.tangoMoveTo(%x SPC %y - 16, 500, "elastic");
		commandToServer('unUseTool');
		JBC_weaponSwitcher_label.reset();
		JBC_weaponSwitcher_active.visible = 0;
	}
	else
	{
	//	setScrollMode($SCROLLMODE_TOOLS);
		%x = %x / 2 - 168;
		%this.tangoMoveTo(%x SPC %y - 82, 500, "elastic");
		JBC_weaponSwitcher_active.visible = 1;
	}
	
	%this.toggled = !%this.toggled;
}

function JBC_weaponSwitcher_label::reset(%this)
{
	%this.setText("<font:arial:16><color:ffffff><just:center>" @ strupr(getWord(moveMap.getBinding("useTools"), 1)) SPC "= weapons");
	clientCmdJBC_weapons_setAmmoLabel();
}

function JBC_weaponSwitcher::setWeapon(%this, %idx, %dir, %toggling, %opening)
{
	if(%dir $= "")
		%dir = JBC_weaponSwitcher.lastDir;
	
	JBC_weaponSwitcher.lastDir = %dir;
	
	for(%i=0; %i < 5; %i++)
	{
		%slot = nameToID("JBC_weaponSwitcher_item" @ %i).icon;
		if(%slot.uiName !$= "")
			%foundItem = 1;
	}
	
	if(!%foundItem)
	{
		cancel(JBC_weaponSwitcher_label.warnSched);
		JBC_weaponSwitcher_label.setText("<font:arial:16><color:ffffff><just:center>You have no weapons!");
		JBC_weaponSwitcher_label.warnSched = JBC_weaponSwitcher_label.schedule(1500, "reset");
		if(JBC_weaponSwitcher.toggled)
			JBC_weaponSwitcher.toggle();
		return;
	}
	
	if(%idx >= 5)
		%idx = 0;
	else if(%idx <= -1)
		%idx = 4;

	if(nameToID("JBC_weaponSwitcher_item" @ %idx).icon.uiName $= "")
	{
		if(%opening && !JBC_weaponSwitcher.toggled)
		{
			cancel(JBC_weaponSwitcher_label.warnSched);
			JBC_weaponSwitcher_label.setText("<font:arial:16><color:ffffff><just:center>Empty slot!");
			JBC_weaponSwitcher_label.warnSched = JBC_weaponSwitcher_label.schedule(1500, "reset");
		}
		else
			JBC_weaponSwitcher.setWeapon(%idx + %dir);
		return;
	}
	
	if(%this.idx == %idx && JBC_weaponSwitcher.toggled && !%toggling)
	{
		JBC_weaponSwitcher.toggle();
		return;
	}
	
	if(!JBC_weaponSwitcher.toggled)
		JBC_weaponSwitcher.toggle();
	
	%this.idx = %idx;
	
	if(%idx == -1)
	{
		JBC_weaponSwitcher_active.visible = 0;
		return;
	}
	
	JBC_weaponSwitcher_active.visible = 1;
	JBC_weaponSwitcher_active.position = %idx * 64 + %idx * 2 SPC 18;
	commandToServer('useTool', %idx);
	JBC_weaponSwitcher_label.setText("<font:arial:16><color:ffffff><just:center>" @ nameToID("JBC_weaponSwitcher_item" @ %idx).icon.uiName);
	$CurrScrollToolSlot = %idx;
}

function clientCmdJBC_weapons_hide()
{
	if(!$JB::Online)
		return;
	
	if(JBC_weaponSwitcher.toggled)
		JBC_weaponSwitcher.toggle();
}

function clientCmdJBC_weapons_set(%idx, %bitmap, %color, %uiName)
{
	if(!$JB::Online)
		return;
	
	%control = nameToID("JBC_weaponSwitcher_item" @ %idx).icon;
	
	if(%bitmap $= "")
		%bitmap = "base/data/shapes/blank";
	
	%control.setBitmap(%bitmap);
	if(%color !$= "")
		%control.mColor = %color;
	else
		%control.mColor = "255 255 255 255";
	
	%control.uiName = %uiName;
}

function clientCmdJBC_weapons_setAmmoLabel(%text)
{
	if(!$JB::Online || !$JB::Pref["HUD"])
		return;
	
	JBC_weaponSwitcher_ammoLabel.setText("<font:arial:16><color:ffffff><just:right>" @ %text);
}

package JBC_weaponSwitcher
{
	function scrollInventory(%on)
	{
		if(!$JB::Online || $ZoomOn)
		{
			parent::scrollInventory(%on);
			return;
		}
		
		%count = Canvas.getCount();
		if (%count > 2)
		{
			%goodCount = %count;
			%i = 0;
			while(%i < %count)
			{
				%name = Canvas.getObject(%i).getName();
				if (%name $= "FrameOverlayGui")
					%goodCount = %goodCount - 1;
				else
					if (%name $= "NetGraphGui")
						%goodCount = %goodCount - 1;
				%i = %i + 1;
			}
			if (%goodCount > 2)
				return;
		}
		
		if(%on > 0)
			%dir = -1;
		else
			%dir = 1;
		JBC_weaponSwitcher.setWeapon(JBC_weaponSwitcher.idx + %dir, %dir);
	}
	
	function useTools(%val)
	{
		if(!$JB::Online)
		{
			parent::useTools(%val);
			return;
		}
		if(!%val)
			return;
		JBC_weaponSwitcher.setWeapon(JBC_weaponSwitcher.idx);
	}
	
	function useBricks(%val)
	{
		if(!$JB::Online)
		{
			parent::useBricks(%val);
			return;
		}
		if(!%val)
			return;
		
		JBC_weaponSwitcher.setWeapon(0, "", "", 1);
	}
	
	function useFirstSlot(%val)
	{
		if(!$JB::Online)
		{
			parent::useFirstSlot(%val);
			return;
		}
		if(!%val)
			return;
		
		JBC_weaponSwitcher.setWeapon(0, "", "", 1);
	}
	
	function useSecondSlot(%val)
	{
		if(!$JB::Online)
		{
			parent::useSecondSlot(%val);
			return;
		}
		if(!%val)
			return;
		
		JBC_weaponSwitcher.setWeapon(1, "", "", 1);
	}
	
	function useThirdSlot(%val)
	{
		if(!$JB::Online)
		{
			parent::useThirdSlot(%val);
			return;
		}
		if(!%val)
			return;
		
		JBC_weaponSwitcher.setWeapon(2, "", "", 1);
	}
	
	function useFourthSlot(%val)
	{
		if(!$JB::Online)
		{
			parent::useFourthSlot(%val);
			return;
		}
		if(!%val)
			return;
		
		JBC_weaponSwitcher.setWeapon(3, "", "", 1);
	}
	
	function useFifthSlot(%val)
	{
		if(!$JB::Online)
		{
			parent::useFifthSlot(%val);
			return;
		}
		if(!%val)
			return;
		
		JBC_weaponSwitcher.setWeapon(4, "", "", 1);
	}
	
	function handleItemPickup(%msgType, %msgString, %slot, %itemData, %silent)
	{
		if($JB::Online)
			playGui.createToolHUD(1);
		parent::handleItemPickup(%msgType, %msgString, %slot, %itemData, %silent);
		if(!$JB::Online)
			return;
		playGui.killToolHud();
		if(%itemData == 0)
		{
			clientCmdJBC_weapons_set(%slot);
			if($CurrScrollToolSlot == %slot)
			{
				clientCmdJBC_weapons_setAmmoLabel();
				JBC_weaponSwitcher_label.setText("");
			}
			return;
		}
		
		%bitmap = %itemData.iconName;
		
		if(%bitmap $= "")
			%bitmap = "Add-Ons/Print_Letters_Default/icons/" @ getSubStr(%itemData.uiName, 0, 1);
		
		
		%color = %itemData.colorShiftColor;
		if(%color !$= "")
			%color = mFloor(getWord(%color, 0) * 255) SPC mFloor(getWord(%color, 1) * 255) SPC mFloor(getWord(%color, 2) * 255) SPC 255;

		clientCmdJBC_weapons_set(%slot, %bitmap, %color, %itemData.uiName);
		
		if($CurrScrollToolSlot == %slot)
			JBC_weaponSwitcher.setWeapon(%slot, "", 1);
	}
	
	function handleYourSpawn(%msgType, %msgString)
	{
		if($JB::Online)
		{
			PlayGui.schedule(0, "killPaint");
			PlayGui.schedule(0, "killInvHud");
			PlayGui.schedule(0, "killToolHud");
			$BrickAutoBuyDone = 1;
		}
		
		parent::handleYourSpawn(%msgType, %msgString);
	}
	
	function handleYourDeath(%msgType, %msgString, %yourName, %killerName, %respawnTime)
	{
		if($JB::Online)
			playGui.createToolHUD(1);
		
		parent::handleYourDeath(%msgType, %msgString, %yourName, %killerName, %respawnTime);
		
		if($JB::Online)
			playGui.killToolHud();
	}
	
	function PlayGui::loadPaint(%this)
	{
		if($JB::Online)
			return;
		
		return parent::loadPaint(%this);
	}
	
	function PlayGui::createInvHUD(%this)
	{
		if($JB::Online)
			return;
		
		return parent::createInvHUD(%this);
	}
	
	function PlayGui::createToolHUD(%this, %bypass)
	{
		if($JB::Online && !%bypass)
			return;
		
		return parent::createToolHUD(%this);
	}
};