// Leaderboard
function clientCmdJBC_getLeaderboard(%cat)
{
	if(!$JB::Online)
		return;
	
	$JB::LoadedLeaderboard = 1;
	connectToURL("http://api.draked.me/cl_leaderboard.php?sort=" @ %cat, "GET", "", "JBC_LeaderboardData", "");
}

function JBC_LeaderboardData::handleText(%this, %text)
{
	%ctrl = JBC_Menu_Tab_Leaderboard_Text;

	%raw = getField(%text, 1);
	%blid = getWord(%raw, getWordCount(%raw) - 1);
	%blid = strReplace(%blid, "(", "");
	%blid = strReplace(%blid, ")", "");
	
	if(%blid == getNumKeyID())
		%rowColor = "\c7";
	else
		%rowColor = "\c6";
	
	for(%i=0; %i < 9; %i++)
	{
		if(%i == 0)
			%row = getField(%text, 0);
		else
		{
			if(%i == 3 && trim(%text) !$= "")
				%row = %row TAB getTimeString(getField(%text, %i));
			else if(%i == 2 && trim(%text !$= ""))
				%row = %row TAB "$" @ numberToString(getField(%text, %i));
			else
				%row = %row TAB getField(%text, %i);
		}
	}
	
	if(trim(%row) $= "")
		return;
	
	%ctrl.addRow(getField(%text, 0), %rowColor @ %row);
}

function JBC_LeaderboardData::onConnected(%this)
{
	JBC_Menu_Tab_Leaderboard_Text.clear();
}


// Staff
function clientCmdJBC_loadStaff()
{
	if(!$JB::Online)
		return;
	
	$JB::LoadedStaff = 1;
	$JB::StaffCount = 0;
	connectToURL("http://api.draked.me/cl_staff.php", "GET", "", "JBC_StaffData", "");
}

function JBC_StaffData::handleText(%this, %text)
{
	if(trim(%text) !$= "")
	{
		$JB::Staff[$JB::StaffCount] = %text;
		$JB::StaffCount++;
	}
}

function JBC_StaffData::onDone(%this, %done)
{
	clientCmdJBC_buildStaff();
}

function clientCmdJBC_buildStaff()
{
	if(!$JB::Online)
		return;
	
	for(%i = JBC_Menu_Tab_Staff_List.getCount() - 1; %i > 0; %i--)
		JBC_Menu_Tab_Staff_List.getObject(%i).delete();
	
	%container = JBC_Menu_Tab_Staff_List;
	%container.clear();
	%currY = 10;
	
	for(%i=0; %i < $JB::StaffCount; %i++)
	{
		%line = $JB::Staff[%i];
		%rank = getField(%line, 3);
		if(%rank $= "SuperAdmin")
			%rank = "Super Admin";
		else if(%rank $= "Administrator")
			%rank = "Admin";
		else if(%rank $= "Owner")
			%rank = "Super Admin";
		
		if(getField(%line, 4) == 1)
		{
			%color = "\c7";
			%lastSeen = "Online";
		}
		else
		{
			%color = "\c0";
			%lastSeen = getField(%line, 2);
		}
		
		if(isObject(%list = nameToID("JBC_StaffList_" @ %rank)))
		{
			%list.addRow(%i, %color @ getField(%line, 1) SPC "(" @ getField(%line, 0) @ ")" TAB %lastSeen);
			%list.extent = "800" SPC getWord(%list.extent, 1) + 10;
			%currY = getWord(%list.position, 1) + getWord(%list.extent, 1);
			continue;
		}
		
		if(%rank !$= %lastRank)
		{
			%lastRank = %rank;

			switch$ (%rank)
			{
				case "Super Admin":
					%icon = "Y_super";
				case "Admin":
					%icon = "X_admin";
				case "Moderator":
					%icon = "W_moderator";
				default:
					%icon = "smile";
			}
			
			%container.add(new GuiMLTextCtrl()
			{
				extent = "800 30";
				text = "<bitmap:Add-Ons/Client_Jailbreak/res/icon/" @ %icon @ "><just:center><font:arial bold:30><color:424242>" @ %rank;
				position = "10" SPC %currY - 4;
			});
			%currY += 30;
			
			
			%textList = new GuiTextListCtrl("JBC_StaffList_" @ %rank)
			{
				profile = "JBC_TextListProfile";
				extent = "800 20";
				position = "0" SPC %currY;
				fitParentWidth = 0;
				columns = "30 648";
			};
			%currY += 30;
			%container.add(%textList);
			%textList.addRow(%i, %color @ getField(%line, 1) SPC "(" @ getField(%line, 0) @ ")" TAB %lastSeen);
		}
	}
	
	%container.resize(0, 0, 800, %currY);
}

// Search results

function JBC_SearchResults::onWake(%this)
{
	if(!%this.centeredOnce)
	{
		%this.centeredOnce = 1;
		JBC_SearchResultsWindow.tangoCenter();
	}
}

function clientCmdJBC_searchWeb(%callback, %search)
{
	if(!$JB::Online)
		return;
	
	JBC_SearchResults_List.clear();
	$JB::searchCallback = %callBack;
	connectToURL("http://api.draked.me/cl_search.php?search=" @ %search, "GET", "", "JBC_SearchData", "");
}

function JBC_SearchData::handleText(%this, %text)
{
	if(trim(%text) $= "")
		return;
	
	if(%text $= "too many results")
	{
		%this.errored = 1;
		clientCmdmessageBoxOK("Crown's Jailbreak", "Too many results. Be more specific.");
		return;
	}
	
	JBC_SearchResults_List.addRow(getField(%text, 0), "\c0" @ getField(%text, 1) TAB getField(%text, 2));
}

function JBC_SearchData::onDone(%this)
{
	if(%this.errored)
		return;
	
	if(JBC_SearchResults_List.rowCount() == 1)
	{
		$JB::searchSelection = JBC_SearchResults_List.getRowTextByID(1);
		clientCmdJBC_search_handleSelect();
	}
	else
	{
		JBC_SearchResults_List.sort(0, 1);
		canvas.pushDialog(JBC_SearchResults);
	}
}

function clientCmdJBC_search_handleSelect()
{
	if(!$JB::Online)
		return;
	
	%callback = $JB::searchCallback;
	if(%callBack $= "")
	{
		error("No callback was set for search.");
		return;
	}
	else
		call(%callBack, $JB::searchSelection);
}

function clientCmdJBC_selectResult()
{
	if(!$JB::Online)
		return;
	
	%result = JBC_SearchResults_List.getRowTextByID(JBC_SearchResults_List.getSelectedID());
	$JB::searchSelection = %result;
}

function JBC_SearchResults_List::onSelect(%this, %a, %selection)
{
	if(%this.lastSelectTime + 0.8 > $Sim::Time && %selection $= %this.lastSelection)
	{
		$JB::searchSelection = JBC_SearchResults_List.getRowTextByID(JBC_SearchResults_List.getSelectedID()); 
		clientCmdJBC_search_handleSelect(); 
		canvas.popDialog(JBC_SearchResults);
	}
	%this.lastSelectTime = $Sim::Time;
	%this.lastSelection = %selection;
}

// Player lookup
function clientCmdJBC_lookUp(%blid)
{
	if(!$JB::Online)
		return;
	
	%blid = getField(%blid, 1);
	%this = connectToURL("http://api.draked.me/cl_lookup.php?blid=" @ %blid, "GET", "", "JBC_LookupData", "");
	%this.bl_id = %blid;
}

function JBC_LookupData::handleText(%this, %text)
{
	if(trim(%text) $= "")
		return;
	
	if(%text $= "error")
	{
		clientCmdJBC_messageBoxOK("Jailbreak", "No results found.");
		return;
	}
	
	%date = getWord(getField(%text, 10), 0);
	if(%date $= "")
		%date = "N/A";
	
	%rank = getWord(getField(%text, 11), 0);
	if(%rank $= "")
		%rank = "User";
	
	JBC_Menu_Profile_Label.setText("<just:center><font:arial:26><color:ffffff>ID:" SPC %this.bl_id @ " Stats");
	JBC_Menu_Tab_Profile_SearchText.setText(getField(%text, 0));
	JBC_Menu_Tab_Profile_SearchText.makeFirstResponder(0);
	JBC_Menu_Profile_Money.setText("\c8$" @ NumberToString(getField(%text, 1)));
	JBC_Menu_Profile_TimePlayed.setText("\c8" @ getTimeString(getField(%text, 2)));
	JBC_Menu_Profile_PrisonerKills.setText("\c8" @ getField(%text, 5));
	JBC_Menu_Profile_GuardKills.setText("\c8" @ getField(%text, 4));
	JBC_Menu_Profile_WardenKills.setText("\c8" @ getField(%text, 3));
	JBC_Menu_Profile_KnifeKills.setText("\c8" @ getField(%text, 7));
	JBC_Menu_Profile_LRWins.setText("\c8" @ getField(%text, 6));
	JBC_Menu_Profile_RoundsPlayed.setText("\c8" @ getField(%text, 8));
	JBC_Menu_Profile_TimesWarden.setText("\c8" @ getField(%text, 9));
	JBC_Menu_Profile_LastSeen.setText("\c8" @ %date);
	JBC_Menu_Profile_Rank.setText("\c8" @ %rank);
}

// Bans
function clientCmdJBC_bansLookUp(%blid)
{
	if(!$JB::Online)
		return;
		
	JBC_Menu_BansInfo.setVisible(false);

	JBC_Menu_Tab_Bans_BLIDLabel.setText("");
	JBC_Menu_Tab_Bans_List.clear();
	%blid = getField(%blid, 1);
	connectToURL("http://api.draked.me/cl_bans.php?blid=" @ %blid, "GET", "", "JBC_BansData", "");
}

function JBC_BansData::handleText(%this, %text)
{
	if(trim(%text) $= "")
		return;
	
	if(%text $= "error" || %text $= "0 results")
	{
		clientCmdJBC_messageBoxOK("Jailbreak", "No results found.");
		return;
	}
	
	%blid = getField(%text, 3);
	%name = getField(%text, 2);
	if(trim(getWord(stripMLControlChars(JBC_Menu_Tab_Bans_BLIDLabel.getValue()), 1)) !$= %blid)
	{
		JBC_Menu_Tab_Bans_BLIDLabel.setText("<font:arial bold:22><just:right><color:ffffff>BL_ID:" SPC %blid);
		JBC_Menu_Tab_Bans_SearchText.setText(%name);
		JBC_Menu_Tab_Bans_SearchText.makeFirstResponder(0);
	}
	
	%type = getField(%text, 4);
	if(%type $= "Guardban")
		%type = "Guard";
	else if(%type $= "Wardenban")
		%type = "Warden";
	
	JBC_Menu_Tab_Bans_List.addRow(getField(%text, 0), "\c0" @ getWord(getField(%text, 1), 0) TAB %type TAB getField(%text, 5) TAB getField(%text, 6) TAB getField(%text, 7));
}